// $Id: FormatingStrategy.java 16590 2009-01-14 01:03:42Z euluis $
// Copyright (c) 2007 The Regents of the University of California. All
// Rights Reserved. Permission to use, copy, modify, and distribute this
// software and its documentation without fee, and without a written
// agreement is hereby granted, provided that the above copyright notice
// and this paragraph appear in all copies. This software program and
// documentation are copyrighted by The Regents of the University of
// California. The software program and documentation are supplied "AS
// IS", without any accompanying services from The Regents. The Regents
// does not warrant that the operation of the program will be
// uninterrupted or error-free. The end-user understands that the program
// was developed for research purposes and is advised not to rely
// exclusively on the program for any reason. IN NO EVENT SHALL THE
// UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
// SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS,
// ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
// THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
// SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
// PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
// CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT,
// UPDATES, ENHANCEMENTS, OR MODIFICATIONS.

package org.argouml.profile;

import java.util.Iterator;

/**
 * Interface for the formating strategy to be used when formating model element
 * names.
 * 
 * @author Marcos Aurlio
 */
public interface FormatingStrategy {
    
    /**
     * Produce a string that represents the specific model element in the
     * context of the specified namespace.
     * 
     * @param element
     *                element to represent.
     * @param namespace
     *                context namespace (may be null).
     * @return a string representing the model element
     */
    String formatElement(Object element, Object namespace);

    /**
     * Produce a string the represents the collection of model elements in the
     * context of the specified namespace.
     * 
     * @param iter
     *                iterator over collection
     * @param namespace
     *                context namespace (may be null).
     * @return a string representing the collection
     */
    String formatCollection(Iterator iter, Object namespace);
}
