// $Id: ActionSetMetaClass.java 12546 2007-05-05 16:54:40Z linus $
// Copyright (c) 2003-2007 The Regents of the University of California. All
// Rights Reserved. Permission to use, copy, modify, and distribute this
// software and its documentation without fee, and without a written
// agreement is hereby granted, provided that the above copyright notice
// and this paragraph appear in all copies. This software program and
// documentation are copyrighted by The Regents of the University of
// California. The software program and documentation are supplied "AS
// IS", without any accompanying services from The Regents. The Regents
// does not warrant that the operation of the program will be
// uninterrupted or error-free. The end-user understands that the program
// was developed for research purposes and is advised not to rely
// exclusively on the program for any reason. IN NO EVENT SHALL THE
// UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
// SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS,
// ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
// THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
// SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
// PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
// CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT,
// UPDATES, ENHANCEMENTS, OR MODIFICATIONS.

package org.argouml.uml.ui.foundation.extension_mechanisms;

import java.awt.event.ActionEvent;
import java.util.Collection;

import javax.swing.Action;

import org.argouml.application.helpers.ResourceLoaderWrapper;
import org.argouml.i18n.Translator;
import org.argouml.model.Model;
import org.argouml.uml.ui.UMLComboBox2;
import org.tigris.gef.undo.UndoableAction;

/**
 * Action to set the baseclass of a stereotype.
 * 
 * TODO: This needs to be extended to support multiple bases classes for a
 * stereotype as added in UML 1.4.
 * 
 * @author mkl
 */
public class ActionSetMetaClass extends UndoableAction {

    /**
     * The Singleton.
     */
    public static final ActionSetMetaClass SINGLETON =
	new ActionSetMetaClass();

    /**
     * Constructor.
     */
    public ActionSetMetaClass() {
        super(Translator.localize("Set"),
                ResourceLoaderWrapper.lookupIcon("Set"));
        // Set the tooltip string:
        putValue(Action.SHORT_DESCRIPTION, 
                Translator.localize("Set"));
    }

    /*
     * @see org.tigris.gef.undo.UndoableAction#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        super.actionPerformed(e);
        Object source = e.getSource();
        Object newBase = null;
        Object stereo = null;
        if (source instanceof UMLComboBox2) {
            UMLComboBox2 combo = (UMLComboBox2) source;
            stereo = combo.getTarget();
            if (Model.getFacade().isAStereotype(stereo)) {
                Collection oldBases = Model.getFacade().getBaseClasses(stereo);
                newBase = combo.getSelectedItem();
                if (newBase != null) { // TODO: How come this happens?
                    if (!oldBases.contains(newBase)) {
                        Model.getExtensionMechanismsHelper().addBaseClass(
                                stereo,
                                newBase);
                    } else {
                        if (newBase != null && newBase.equals("")) {
                            Model.getExtensionMechanismsHelper().addBaseClass(
                                    stereo, "ModelElement");
                        }
                    }
                }
            }
        }
    }
}
