package ch.ige.adr.client;

import java.awt.Color;
import java.awt.ComponentOrientation;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.BorderFactory;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.SwingConstants;
import javax.swing.border.TitledBorder;

import org.apache.log4j.Logger;

import ch.ige.main.client.PnlWizard;
import ch.ige.main.client.XxMessage;
import ch.ige.util.vo.VersadrVO;


/**
 * Erfassen und Mutieren der Versandadresse
 * <p>
 * Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: PnlAdresseSap.java,v 1.20 2007/06/06 07:34:42 nydegger Exp $
 */
public class PnlAdresseSap extends PnlWizard
{
  // Logging
  private static final Logger LOG = Logger.getLogger(PnlAdresseSap.class);

  // Applikationsmeldungen
  protected XxMessage xxMessage = null;

  protected VersadrVO versadrVO = null;

  protected TitledBorder titledBorder1;
  protected JLabel lblCustGroup = new JLabel();
  protected JLabel lblTaxClass = new JLabel();
  protected JLabel lblCustGrp1 = new JLabel();
  protected JComboBox cbxTaxClass = new JComboBox();
  protected DefaultComboBoxModel cbmTaxClass = new DefaultComboBoxModel();
  protected JCheckBox ckbCustGroup = new JCheckBox();
  protected JCheckBox ckbCustGrp1 = new JCheckBox();
  private JLabel lblNurFRC = new JLabel();

  /**
   * Konstuktor
   */
  public PnlAdresseSap()
  {
    super();
    focusOwner = cbxTaxClass;
    try
    {
      xxMessage = XxMessage.getInstance();
      jbInit();
    }
    catch(Exception ex)
    {
      LOG.error(ex);
      JOptionPane.showMessageDialog(parentWindow, ex.getMessage(),
                                    "Fehler", JOptionPane.ERROR_MESSAGE);
    }
  }


  /**
   * Komponente initialisieren
   * @throws Exception
   */
  protected void jbInit() throws Exception
  {
    cbmTaxClass.addElement(new Item("0", "steuerbefreit"));
    cbmTaxClass.addElement(new Item("1", "steuerpflichtig"));
    cbmTaxClass.addElement(new Item("6", "internationale Organisation"));
    ckbCustGrp1.setHorizontalAlignment(SwingConstants.LEFT);
    ckbCustGrp1.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
    ckbCustGrp1.setHorizontalTextPosition(SwingConstants.LEFT);
    cbxTaxClass.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
    cbxTaxClass.setPreferredSize(new Dimension(40, 25));
    ckbCustGroup.setHorizontalAlignment(SwingConstants.LEFT);
    ckbCustGroup.setHorizontalTextPosition(SwingConstants.LEFT);
    GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
    gridBagConstraints6.insets = new Insets(10, 5, 131, 197);
    gridBagConstraints6.gridy = 3;
    gridBagConstraints6.gridx = 1;
    GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
    gridBagConstraints5.insets = new Insets(9, 5, 9, 197);
    gridBagConstraints5.gridy = 2;
    gridBagConstraints5.fill = GridBagConstraints.NONE;
    gridBagConstraints5.gridx = 1;
    GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
    gridBagConstraints4.insets = new Insets(11, 16, 14, 11);
    gridBagConstraints4.gridy = 2;
    gridBagConstraints4.ipadx = 14;
    gridBagConstraints4.gridx = 0;
    GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
    gridBagConstraints3.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints3.gridx = 1;
    gridBagConstraints3.gridy = 1;
    gridBagConstraints3.ipadx = 169;
    gridBagConstraints3.ipady = -2;
    gridBagConstraints3.weightx = 1.0;
    gridBagConstraints3.insets = new Insets(18, 11, 9, 18);
    GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
    gridBagConstraints2.insets = new Insets(21, 19, 15, 11);
    gridBagConstraints2.gridy = 1;
    gridBagConstraints2.ipadx = 11;
    gridBagConstraints2.gridx = 0;
    GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
    gridBagConstraints1.insets = new Insets(12, 14, 136, 11);
    gridBagConstraints1.gridy = 3;
    gridBagConstraints1.ipadx = 16;
    gridBagConstraints1.gridx = 0;
    GridBagConstraints gridBagConstraints = new GridBagConstraints();
    gridBagConstraints.insets = new Insets(24, 93, 17, 60);
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 0;
    gridBagConstraints.gridwidth = 2;
    this.setSize(new Dimension(450, 334));
    this.setPreferredSize(new Dimension(450, 334));
    titledBorder1 = new TitledBorder(null,"Adresse SAP");
    this.setLayout(new GridBagLayout());
    this.setBorder(BorderFactory.createTitledBorder(null, "Adresse SAP", TitledBorder.LEADING, TitledBorder.TOP, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
    lblCustGroup.setMaximumSize(new Dimension(170, 14));
    lblCustGroup.setMinimumSize(new Dimension(170, 14));
    lblCustGroup.setPreferredSize(new Dimension(170, 14));
    lblCustGroup.setHorizontalAlignment(SwingConstants.RIGHT);
    lblCustGroup.setText("Deponentenkonto:");
    cbxTaxClass.setModel(cbmTaxClass);
    lblTaxClass.setMaximumSize(new Dimension(170, 14));
    lblTaxClass.setMinimumSize(new Dimension(170, 14));
    lblTaxClass.setPreferredSize(new Dimension(170, 14));
    lblTaxClass.setHorizontalAlignment(SwingConstants.RIGHT);
    lblTaxClass.setText("Mehrwertsteuerklassifikation:");
    lblCustGrp1.setMaximumSize(new Dimension(170, 14));
    lblCustGrp1.setMinimumSize(new Dimension(170, 14));
    lblCustGrp1.setPreferredSize(new Dimension(170, 14));
    lblCustGrp1.setHorizontalAlignment(SwingConstants.RIGHT);
    lblCustGrp1.setText("Bescheinigung:");
    lblNurFRC.setFont(new java.awt.Font("Dialog", 1, 12));
    lblNurFRC.setForeground(Color.red);
    lblNurFRC.setText("Diese Felder dürfen nur von FRC verändert werden!");
    this.add(lblNurFRC, gridBagConstraints);
    this.add(lblCustGrp1, gridBagConstraints1);
    this.add(lblTaxClass, gridBagConstraints2);
    this.add(cbxTaxClass, gridBagConstraints3);
    this.add(lblCustGroup, gridBagConstraints4);
    this.add(ckbCustGroup, gridBagConstraints5);
    this.add(ckbCustGrp1, gridBagConstraints6);
  }

  /**
   * Gibt die Versandadresse zurück
   * @return VersadrVO
   */
  public VersadrVO getVersadr()
  {
    // Mehrwertsteuerklassifikation
    versadrVO.setTaxClass(((Item)cbxTaxClass.getSelectedItem()).getKey());
    // Kundengruppe
    if (ckbCustGroup.isSelected())
    {
      versadrVO.setCustGroup("01");// mit Deponentenkonto
    }
    else
    {
      versadrVO.setCustGroup("02"); // ohne Deponentenkonto
    }
    // Bescheinigung
    if (ckbCustGrp1.isSelected())
    {
      versadrVO.setCustGrp1("001");  // mit Bescheinigung
    }
    else
    {
      versadrVO.setCustGrp1(null);  // ohne Bescheinigung
    }
    return versadrVO;
  }

  /**
   * Setzt die Versandadresse
   * @param versadrVO Versandadresse
   */
  public void setVersadr(VersadrVO versadrVO)
  {
    this.versadrVO = versadrVO;
    // Mehrwertsteuerklassifikation setzen
    for(int i = 0; i < cbmTaxClass.getSize(); i++)
    {
      Item item = (Item)cbmTaxClass.getElementAt(i);
      if (item.getKey().equals(versadrVO.getTaxClassOrEmptyStr()))
      {
        cbmTaxClass.setSelectedItem(item);
        break;
      }
    }
    ckbCustGroup.setSelected(versadrVO.getCustGroupOrEmptyStr().equals("01"));
    ckbCustGrp1.setSelected(versadrVO.getCustGrp1OrEmptyStr().equals("001"));
  }

  /**
   * Item der Steuerklassifikation
   * <p>
   * Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum
   * @author  Ueli Ryser
   * @version $Id: PnlAdresseSap.java,v 1.20 2007/06/06 07:34:42 nydegger Exp $
   */
  public class Item
  {
    private String key;      // Schlüssel
    private String text;     // Text

    /**
     * Konstruktor
     * @param key Schlüssel
     * @param text Text
     */
    public Item(String key, String text)
    {
      this.key = key;
      this.text = text;
    }

    /**
     * Gibt den Schlüssel zurück.
     * @return Schlüssel
     */
    public String getKey()
    {
      return key;
    }

    /**
     * Gibt den Text zurück.
     * @return Text
     */
    public String toString()
    {
      return text;
    }
  }
}  //  @jve:decl-index=0:visual-constraint="10,10"
