package ch.ige.adr.client;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.FocusEvent;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.border.TitledBorder;
import javax.swing.table.JTableHeader;

import org.apache.log4j.Logger;

import ch.ige.adr.server.AdresseDelegate;
import ch.ige.adr.vo.RegadrAVO;
import ch.ige.adr.vo.RegadrSelKritVO;
import ch.ige.adrhelp.HelpUtil;
import ch.ige.authz.gui.GUIAuthorizer;
import ch.ige.main.client.GlassComponent;
import ch.ige.main.client.MainController;
import ch.ige.main.client.MainRootPane;
import ch.ige.main.client.XxMessage;
import ch.ige.util.client.IgeTable;
import ch.ige.util.client.LimitedDocument;
import ch.ige.util.client.SwingWorker;
import ch.ige.util.client.TableSorterView;

/**
 * Auswahl der Registeradressen
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: RegadrAwl.java,v 1.47 2008/04/28 15:32:34 galli Exp $
 */
public class RegadrAwl extends ch.ige.main.client.SelectionPane
{
  // Logging
  private static final Logger LOG = Logger.getLogger( RegadrAwl.class );

  // Applikationsmeldungen
  protected XxMessage xxMessage = null;

  // Detail-Pane
  protected RegadrDtl regadrDtl = null;

  // selektierte Adressnummer
  protected int selRegadrNr = 0; // 0 == keine Adresse selektiert

  //Frame konstruieren
  protected JPanel mainPanel = new JPanel(); //  @jve:decl-index=0:visual-constraint="10,72"

  protected JPanel selKrit = new JPanel();

  protected JPanel selTablePanel = new JPanel();

  protected JScrollPane selTableScrollPane = new JScrollPane();

  protected BorderLayout borderLayout22 = new BorderLayout();

  // Adressen Tabelle
  protected RegadrTableModel tableModel = new RegadrTableModel();

  protected TableSorterView tableSorterView = new TableSorterView( tableModel );

  protected IgeTable selTable = new IgeTable( tableSorterView );

  protected JLabel lblRegadrNr = new JLabel();

  protected JLabel lblSortiername = new JLabel();

  protected JLabel lblRegName = new JLabel();

  protected JTextField txfRegadrNr = new JTextField();

  protected JTextField txfSuchbegr = new JTextField();

  protected JTextField txfRegName = new JTextField();

  protected JTextField txfRegOrt = new JTextField();

  protected JLabel lblRegOrt = new JLabel();

  protected JTextField txfLandCd = new JTextField();

  protected JLabel lblLandCd = new JLabel();

  protected LimitedDocument ldoRegadrNr = new LimitedDocument();

  protected LimitedDocument ldoSortiername = new LimitedDocument();

  protected LimitedDocument ldoRegName = new LimitedDocument();

  protected LimitedDocument ldoRegOrt = new LimitedDocument();

  protected LimitedDocument ldoLand = new LimitedDocument();

  protected LimitedDocument ldoAdrNr = new LimitedDocument();

  protected JLabel lblNurVersAdr = new JLabel();

  protected JLabel lblNurChLi = new JLabel();

  protected ButtonGroup bgrSuche = new ButtonGroup(); //  @jve:decl-index=0:

  protected JRadioButton rbnIndex = new JRadioButton();

  protected JRadioButton rbnVolltext = new JRadioButton();

  protected JLabel lblSuche = new JLabel();

  protected JCheckBox cbxNurVersAdr = new JCheckBox();

  protected JCheckBox cbxNurChLi = new JCheckBox();

  protected JLabel lblMenge = new JLabel();

  protected JRadioButton rbnAlle = new JRadioButton();

  protected JRadioButton rbnNurGueltige = new JRadioButton();

  protected JRadioButton rbnNurGesperrte = new JRadioButton();

  protected ButtonGroup bgrMenge = new ButtonGroup();

  protected JTextField txfAdrNr = new JTextField();

  protected JLabel lblAdrNr = new JLabel();

  /**
   * Konstruktor
   */
  public RegadrAwl()
  {
    try
    {
      xxMessage = XxMessage.getInstance();
      jbInit();
      GUIAuthorizer.authorizeFieldsIn( this );
      initHelp();
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      JOptionPane.showMessageDialog( mainController.getWindow(), ex.getMessage(), "Fehler", JOptionPane.ERROR_MESSAGE );
    }
  }

  /**
   * Konstuktor
   * @param mainController Hauptsteuerung
   * @param mode Modus MainRootPane.SEARCH oder MainRootPane.SEARCH_LOOKUP
   */
  public RegadrAwl( MainController mainController, int mode )
  {
    super( mainController, mode );
    focusOwner = txfRegadrNr;
    try
    {
      xxMessage = XxMessage.getInstance();
      jbInit();
      GUIAuthorizer.authorizeFieldsIn( this );
      initHelp();
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      JOptionPane.showMessageDialog( mainController.getWindow(), ex.getMessage(), "Fehler", JOptionPane.ERROR_MESSAGE );
    }
  }

  /**
   * Komponente initialisieren
   * @throws Exception
   */
  void jbInit() throws Exception
  {
    borderLayout22.setHgap( 0 );
    txfLandCd.setHorizontalAlignment( JTextField.LEFT );
    mainPanel.setSize( new Dimension( 754, 518 ) );
    txfAdrNr.setHorizontalAlignment( JTextField.LEFT );
    txfRegOrt.setHorizontalAlignment( JTextField.LEFT );
    txfRegName.setHorizontalAlignment( JTextField.LEFT );
    txfSuchbegr.setHorizontalAlignment( JTextField.LEFT );
    txfSuchbegr.setPreferredSize( new Dimension( 4, 107 ) );
    txfRegadrNr.setHorizontalAlignment( JTextField.LEFT );
    GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
    gridBagConstraints22.insets = new Insets( 5, 10, 2, 4 );
    gridBagConstraints22.gridy = 5;
    gridBagConstraints22.ipadx = 32;
    gridBagConstraints22.anchor = GridBagConstraints.EAST;
    gridBagConstraints22.gridx = 0;
    GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
    gridBagConstraints21.insets = new Insets( 5, 10, 0, 4 );
    gridBagConstraints21.gridy = 6;
    gridBagConstraints21.ipadx = 0;
    gridBagConstraints21.anchor = GridBagConstraints.EAST;
    gridBagConstraints21.gridx = 0;
    GridBagConstraints gridBagConstraints20 = new GridBagConstraints();
    gridBagConstraints20.insets = new Insets( 5, 10, 3, 4 );
    gridBagConstraints20.gridy = 4;
    gridBagConstraints20.ipadx = 109;
    gridBagConstraints20.anchor = GridBagConstraints.EAST;
    gridBagConstraints20.gridx = 0;
    GridBagConstraints gridBagConstraints19 = new GridBagConstraints();
    gridBagConstraints19.insets = new Insets( 5, 6, 0, 0 );
    gridBagConstraints19.gridx = 5;
    gridBagConstraints19.gridy = 6;
    gridBagConstraints19.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints19.weightx = 1.0;
    gridBagConstraints19.gridheight = 1;
    GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
    gridBagConstraints18.insets = new Insets( 5, 6, 15, 0 );
    gridBagConstraints18.gridx = 4;
    gridBagConstraints18.gridy = 7;
    gridBagConstraints18.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints18.gridheight = 1;
    GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
    gridBagConstraints17.insets = new Insets( 5, 6, 0, 0 );
    gridBagConstraints17.gridx = 4;
    gridBagConstraints17.gridy = 6;
    gridBagConstraints17.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints17.gridheight = 1;
    GridBagConstraints gridBagConstraints16 = new GridBagConstraints();
    gridBagConstraints16.insets = new Insets( 5, 6, 15, 0 );
    gridBagConstraints16.gridx = 3;
    gridBagConstraints16.gridy = 7;
    gridBagConstraints16.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints16.gridheight = 1;
    GridBagConstraints gridBagConstraints15 = new GridBagConstraints();
    gridBagConstraints15.insets = new Insets( 5, 6, 0, 0 );
    gridBagConstraints15.gridx = 3;
    gridBagConstraints15.gridy = 6;
    gridBagConstraints15.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints15.gridheight = 1;
    GridBagConstraints gridBagConstraints14 = new GridBagConstraints();
    gridBagConstraints14.insets = new Insets( 8, 5, 15, 0 );
    gridBagConstraints14.gridy = 7;
    gridBagConstraints14.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints14.weightx = 0.0D;
    gridBagConstraints14.gridx = 2;
    GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
    gridBagConstraints13.insets = new Insets( 5, 5, 0, 0 );
    gridBagConstraints13.gridy = 6;
    gridBagConstraints13.anchor = GridBagConstraints.WEST;
    gridBagConstraints13.weightx = 0.0D;
    gridBagConstraints13.gridx = 2;
    GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
    gridBagConstraints12.insets = new Insets( 5, 5, 15, 0 );
    gridBagConstraints12.gridx = 1;
    gridBagConstraints12.gridy = 7;
    gridBagConstraints12.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints12.gridheight = 1;
    GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
    gridBagConstraints11.insets = new Insets( 7, 10, 0, 4 );
    gridBagConstraints11.gridy = 7;
    gridBagConstraints11.ipadx = 73;
    gridBagConstraints11.anchor = GridBagConstraints.NORTHEAST;
    gridBagConstraints11.gridx = 0;
    GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
    gridBagConstraints10.insets = new Insets( 5, 5, 0, 0 );
    gridBagConstraints10.gridx = 1;
    gridBagConstraints10.gridy = 6;
    gridBagConstraints10.anchor = GridBagConstraints.WEST;
    gridBagConstraints10.gridheight = 1;
    GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
    gridBagConstraints9.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints9.gridwidth = 2;
    gridBagConstraints9.gridx = 1;
    gridBagConstraints9.gridy = 5;
    gridBagConstraints9.ipadx = 75;
    gridBagConstraints9.weightx = 0.0;
    gridBagConstraints9.anchor = GridBagConstraints.WEST;
    gridBagConstraints9.insets = new Insets( 2, 6, 1, 0 );
    GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
    gridBagConstraints8.insets = new Insets( 5, 10, 3, 4 );
    gridBagConstraints8.gridy = 1;
    gridBagConstraints8.ipadx = 66;
    gridBagConstraints8.anchor = GridBagConstraints.EAST;
    gridBagConstraints8.gridx = 0;
    GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
    gridBagConstraints7.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints7.gridwidth = 5;
    gridBagConstraints7.gridx = 1;
    gridBagConstraints7.gridy = 3;
    gridBagConstraints7.ipadx = 324;
    gridBagConstraints7.weightx = 0.0;
    gridBagConstraints7.anchor = GridBagConstraints.WEST;
    gridBagConstraints7.insets = new Insets( 2, 6, 2, 0 );
    GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
    gridBagConstraints6.insets = new Insets( 5, 10, 3, 4 );
    gridBagConstraints6.gridy = 3;
    gridBagConstraints6.ipadx = 73;
    gridBagConstraints6.anchor = GridBagConstraints.EAST;
    gridBagConstraints6.gridx = 0;
    GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
    gridBagConstraints5.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints5.gridwidth = 5;
    gridBagConstraints5.gridx = 1;
    gridBagConstraints5.gridy = 2;
    gridBagConstraints5.ipadx = 324;
    gridBagConstraints5.weightx = 0.0;
    gridBagConstraints5.anchor = GridBagConstraints.WEST;
    gridBagConstraints5.insets = new Insets( 2, 6, 2, 0 );
    GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
    gridBagConstraints4.insets = new Insets( 5, 10, 3, 4 );
    gridBagConstraints4.gridy = 2;
    gridBagConstraints4.ipadx = 57;
    gridBagConstraints4.anchor = GridBagConstraints.EAST;
    gridBagConstraints4.gridx = 0;
    GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
    gridBagConstraints3.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints3.gridwidth = 3;
    gridBagConstraints3.gridx = 1;
    gridBagConstraints3.gridy = 1;
    gridBagConstraints3.ipadx = 107;
    gridBagConstraints3.weightx = 0.0;
    gridBagConstraints3.anchor = GridBagConstraints.WEST;
    gridBagConstraints3.insets = new Insets( 2, 6, 2, 0 );
    GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
    gridBagConstraints2.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints2.gridwidth = 2;
    gridBagConstraints2.gridx = 1;
    gridBagConstraints2.gridy = 0;
    gridBagConstraints2.ipadx = 75;
    gridBagConstraints2.weightx = 0.0;
    gridBagConstraints2.anchor = GridBagConstraints.WEST;
    gridBagConstraints2.insets = new Insets( 20, 6, 2, 0 );
    GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
    gridBagConstraints1.insets = new Insets( 20, 10, 3, 4 );
    gridBagConstraints1.gridy = 0;
    gridBagConstraints1.ipadx = 32;
    gridBagConstraints1.anchor = GridBagConstraints.EAST;
    gridBagConstraints1.gridx = 0;
    GridBagConstraints gridBagConstraints = new GridBagConstraints();
    gridBagConstraints.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints.gridx = 1;
    gridBagConstraints.gridy = 4;
    gridBagConstraints.ipadx = 31;
    gridBagConstraints.weightx = 0.0;
    gridBagConstraints.anchor = GridBagConstraints.WEST;
    gridBagConstraints.gridwidth = 1;
    gridBagConstraints.insets = new Insets( 2, 6, 1, 0 );
    mainPanel.setLayout( new BorderLayout() );

    selKrit.setMaximumSize( new Dimension( 2147483647, 220 ) );
    selKrit.setMinimumSize( new Dimension( 300, 220 ) );
    selKrit.setPreferredSize( new Dimension( 300, 250 ) );
    selKrit.setLayout( new GridBagLayout() );

    selTable.setPreferredScrollableViewportSize( new Dimension( 450, 50 ) );
    selTablePanel.setLayout( borderLayout22 );
    lblRegadrNr.setHorizontalAlignment( SwingConstants.RIGHT );
    lblRegadrNr.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblRegadrNr.setText( "Registeradress-Nr:" );
    lblSortiername.setHorizontalAlignment( SwingConstants.RIGHT );
    lblSortiername.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblSortiername.setText( "Sortiername:" );
    lblRegName.setToolTipText( "" );
    lblRegName.setHorizontalAlignment( SwingConstants.RIGHT );
    lblRegName.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblRegName.setText( "Registername:" );

    lblRegOrt.setHorizontalAlignment( SwingConstants.RIGHT );
    lblRegOrt.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblRegOrt.setText( "Registerort:" );
    lblLandCd.setHorizontalAlignment( SwingConstants.RIGHT );
    lblLandCd.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblLandCd.setText( "Land:" );
    txfRegadrNr.setDocument( ldoRegadrNr );
    txfSuchbegr.setDocument( ldoSortiername );
    txfRegName.setDocument( ldoRegName );
    txfRegOrt.setDocument( ldoRegOrt );
    txfLandCd.setDocument( ldoLand );
    txfAdrNr.setDocument( ldoAdrNr );
    lblNurVersAdr.setHorizontalAlignment( SwingConstants.RIGHT );
    lblNurVersAdr.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblNurVersAdr.setText( "nur mit Versandadresse:" );
    lblNurChLi.setHorizontalAlignment( SwingConstants.RIGHT );
    lblNurChLi.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblNurChLi.setText( "nur in CH/LI:" );
    rbnIndex.setText( "Index" );
    rbnVolltext.setText( "Volltext" );
    lblSuche.setText( "Suche:" );
    lblSuche.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblSuche.setHorizontalAlignment( SwingConstants.RIGHT );
    lblMenge.setText( "Menge:" );
    lblMenge.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblMenge.setHorizontalAlignment( SwingConstants.RIGHT );
    rbnAlle.setText( "Alle" );
    rbnNurGueltige.setText( "nur Gültige" );
    rbnNurGesperrte.setText( "nur gesperrte" );
    txfAdrNr.setDocument( ldoAdrNr );
    txfRegadrNr.setDocument( ldoRegadrNr );
    lblAdrNr.setHorizontalAlignment( SwingConstants.RIGHT );
    lblAdrNr.setHorizontalTextPosition( SwingConstants.RIGHT );
    lblAdrNr.setText( "Versandadress-Nr:" );
    centerPanel.add( mainPanel, BorderLayout.CENTER );
    selKrit.setBorder( BorderFactory.createTitledBorder( null, "Selektionskriterien", TitledBorder.LEADING, TitledBorder.TOP,
        new Font( "Dialog", Font.BOLD, 12 ), new Color( 51, 51, 51 ) ) );
    mainPanel.add( selKrit, BorderLayout.NORTH );
    mainPanel.add( selTablePanel, BorderLayout.CENTER );
    selTablePanel.setBorder( new TitledBorder( "Registeradressen" ) );

    selTablePanel.add( selTableScrollPane, BorderLayout.CENTER );
    selKrit.add( txfLandCd, gridBagConstraints );
    selKrit.add( lblRegadrNr, gridBagConstraints1 );
    selKrit.add( txfRegadrNr, gridBagConstraints2 );
    selKrit.add( txfSuchbegr, gridBagConstraints3 );
    selKrit.add( lblRegName, gridBagConstraints4 );
    selKrit.add( txfRegName, gridBagConstraints5 );
    selKrit.add( lblRegOrt, gridBagConstraints6 );
    selKrit.add( txfRegOrt, gridBagConstraints7 );
    selKrit.add( lblSortiername, gridBagConstraints8 );
    selKrit.add( txfAdrNr, gridBagConstraints9 );
    selKrit.add( cbxNurVersAdr, gridBagConstraints10 );
    selKrit.add( lblNurChLi, gridBagConstraints11 );
    selKrit.add( cbxNurChLi, gridBagConstraints12 );
    selKrit.add( lblMenge, gridBagConstraints13 );
    selKrit.add( lblSuche, gridBagConstraints14 );
    selKrit.add( rbnAlle, gridBagConstraints15 );
    selKrit.add( rbnIndex, gridBagConstraints16 );
    selKrit.add( rbnNurGueltige, gridBagConstraints17 );
    selKrit.add( rbnVolltext, gridBagConstraints18 );
    selKrit.add( rbnNurGesperrte, gridBagConstraints19 );
    selKrit.add( lblLandCd, gridBagConstraints20 );
    selKrit.add( lblNurVersAdr, gridBagConstraints21 );
    selKrit.add( lblAdrNr, gridBagConstraints22 );
    selTableScrollPane.getViewport().add( selTable );
    // Tabelle
    tableSorterView.addMouseListenerToHeaderInTable( selTable );

    JTableHeader header = selTable.getTableHeader();
    header.addMouseListener( new MouseAdapter()
    {
      public void mouseClicked( MouseEvent e )
      {
        header_MouseListener( e );
      }
    } );

    // Spaltenbreite der Tabelle
    selTable.getColumnModel().getColumn( 0 ).setPreferredWidth( 80 );
    selTable.getColumnModel().getColumn( 1 ).setPreferredWidth( 80 );
    selTable.getColumnModel().getColumn( 2 ).setPreferredWidth( 150 );
    selTable.getColumnModel().getColumn( 3 ).setPreferredWidth( 50 );
    selTable.getColumnModel().getColumn( 4 ).setPreferredWidth( 100 );
    selTable.getColumnModel().getColumn( 5 ).setPreferredWidth( 30 );
    selTable.getColumnModel().getColumn( 6 ).setPreferredWidth( 80 );

    selTable.addMouseListener( new MouseAdapter()
    {
      public void mouseClicked( MouseEvent e )
      {
        selTable_MouseListener( e );
      }
    } );
    selTable.addFocusListener( new java.awt.event.FocusAdapter()
    {
      public void focusGained( FocusEvent e )
      {
        selTable_focusGained( e );
      }
    } );
    selTable.addFocusListener( new java.awt.event.FocusAdapter()
    {
      public void focusLost( FocusEvent e )
      {
        selTable_focusLost( e );
      }
    } );
    selTable.addKeyListener( new java.awt.event.KeyAdapter()
    {
      public void keyPressed( KeyEvent e )
      {
        selTable_keyPressed( e );
      }
    } );
    ldoRegadrNr.setMaxLength( 10 );
    ldoRegadrNr.setInteger( true );
    ldoSortiername.setMaxLength( 30 );
    ldoSortiername.setUpperCase( true );
    ldoRegName.setMaxLength( 50 );
    ldoRegOrt.setMaxLength( 50 );
    ldoLand.setMaxLength( 3 );
    ldoLand.setUpperCase( true );
    ldoAdrNr.setMaxLength( 10 );
    ldoAdrNr.setInteger( true );

    rbnAlle.setSelected( true );
    rbnIndex.setSelected( true );
    bgrMenge.add( rbnAlle );
    bgrMenge.add( rbnNurGueltige );
    bgrMenge.add( rbnNurGesperrte );
    bgrSuche.add( rbnIndex );
    bgrSuche.add( rbnVolltext );
    cbxNurVersAdr.setSelected( false );
    cbxNurVersAdr.setHorizontalAlignment( SwingConstants.LEFT );
    cbxNurChLi.setSelected( true );

    cbxNurChLi.setHorizontalAlignment( SwingConstants.LEFT );
    setGlassPane( new GlassComponent() );
    setStateNotFound();

  } // jbInit

  //********** Öffentliche Standard-Methoden *******************************

  /**
   * Gibt den Titel für das Frame zurück
   * @return Titel
   */
  public String getTitle()
  {
    return "Registeradresse Auswahl";
  }

  //********** Lokale Standard-Methoden **********************************

  //********** Ereignisbehandlung zu Menus *******************************

  //********** Menu Datei ************************************************

  /**
   * Das Neu-Menü wurde gewählt.
   * Erfassungswizard anzeigen.
   * @param e ActionEvent
   */
  protected void mnuNew_actionPerformed( ActionEvent e )
  {
    statusBar.setText( " " );
    RegadrWizard rw = new RegadrWizard( (Frame) mainController.getWindow() );
    Integer regadrNr;
    try
    {
      regadrNr = rw.newRegadr();
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      String message = xxMessage.getMessage( ex );
      JOptionPane.showMessageDialog( mainController.getWindow(), message, "Fehler", JOptionPane.ERROR_MESSAGE );
      return;
    }
    if ( regadrNr == null )
    {
      // Erfassen wurde abgebrochen
      String message = xxMessage.getMessage( 1033 );
      statusBar.setText( message );
    }
    else
    {
      setForwardEnabled( true );
      regadrDtl = new RegadrDtl( mainController, MainRootPane.DETAIL );
      regadrDtl.setKey( regadrNr );
      regadrDtl.read();
      // Datensatz gespeichert.
      String message = xxMessage.getMessage( 1004 );
      regadrDtl.setStatusBar( message );
      mainController.next( regadrDtl );
    }
  }

  /**
   * Das Suchen-Menü wurde gewählt,
   * Daten für Auswahl suchen und anzeigen
   * @param e ActionEvent
   */
  protected void mnuFind_actionPerformed( ActionEvent e )
  {
    tableModel.clear();
    // Bitte warten...
    String message = xxMessage.getMessage( 1 );
    statusBar.setText( message );

    // Selektionskriterien abfüllen
    final RegadrSelKritVO selKrit = new RegadrSelKritVO();
    try
    {
      selKrit.regadrNr = Integer.parseInt( txfRegadrNr.getText() );
    }
    catch ( NumberFormatException ex )
    {
      selKrit.regadrNr = 0;
    }
    selKrit.upVerzName = txfSuchbegr.getText().trim();
    selKrit.regName = txfRegName.getText().trim();
    selKrit.regOrt = txfRegOrt.getText().trim();
    selKrit.blandCd = txfLandCd.getText().trim();
    try
    {
      selKrit.adrNr = Integer.parseInt( txfAdrNr.getText() );
    }
    catch ( NumberFormatException ex )
    {
      selKrit.adrNr = 0;
    }
    // Suchmodus für "nur mit Versandadressen" setzen
    selKrit.nurMitVersAdr = cbxNurVersAdr.isSelected();
    // Suchmodus für "nur in CH/LI" setzen
    selKrit.nurChLi = cbxNurChLi.isSelected();
    // Suchmodus für Menge setzen
    if ( rbnAlle.isSelected() )
    {
      selKrit.suchumfang = RegadrSelKritVO.SUCHUMFANG_ALLE;
    }
    else if ( rbnNurGueltige.isSelected() )
    {
      selKrit.suchumfang = RegadrSelKritVO.SUCHUMFANG_NUR_GUELTIGE;
    }
    else if ( rbnNurGesperrte.isSelected() )
    {
      selKrit.suchumfang = RegadrSelKritVO.SUCHUMFANG_NUR_GESPERRTE;
    }
    // Suchmodus Index- oder Volltextsuche setzen
    selKrit.suchmodusVolltext = rbnVolltext.isSelected();

    if ( selKrit.regadrNr == 0 && selKrit.upVerzName.length() == 0 && selKrit.regName.length() == 0 && selKrit.regStrasse.length() == 0
        && selKrit.regOrt.length() == 0 && selKrit.adrNr == 0 )
    {
      if ( selKrit.blandCd.length() == 0 )
      {
        // Es muss mindestens ein Suchkriterium abgefüllt sein.
        message = xxMessage.getMessage( 1112 );
        JOptionPane.showMessageDialog( null, message, "Information", JOptionPane.INFORMATION_MESSAGE );
        statusBar.setText( " " );
        return;
      }
      else
      {
        // Nach 'Land' kann nicht allein gesucht werden. Bitte weitere Suchbegriffe eingeben.
        message = xxMessage.getMessage( 1226 );
        JOptionPane.showMessageDialog( null, message, "Information", JOptionPane.INFORMATION_MESSAGE );
        statusBar.setText( " " );
        return;
      }
    }

    if ( selKrit.suchmodusVolltext )
    {
      message = xxMessage.getMessage( 1032 );
      Object[] options = { "OK", "Abbrechen" };
      int selectedOption = JOptionPane.showOptionDialog( mainController.getWindow(), message, "Information", JOptionPane.DEFAULT_OPTION,
          JOptionPane.INFORMATION_MESSAGE, null, options, options[1] );
      if ( selectedOption == 1 )
      {
        // Abbrechen
        statusBar.setText( " " );
        return;
      }
    }

    getGlassPane().setVisible( true );
    // Daten lesen
    final SwingWorker worker = new SwingWorker()
    {
      public Object construct()
      {
        ArrayList regadrAL;
        try
        {
          AdresseDelegate ad = AdresseDelegate.getInstance();
          regadrAL = ad.findRegadr( selKrit );
        }
        catch ( Exception ex )
        {
          LOG.error( ex );
          String message = xxMessage.getMessage( ex );
          JOptionPane.showMessageDialog( mainController.getWindow(), message, "Fehler", JOptionPane.ERROR_MESSAGE );
          return null;
        }
        RegadrAVO[] regadrAVO = new RegadrAVO[regadrAL.size()];
        regadrAL.toArray( regadrAVO );
        tableModel.setData( regadrAVO );
        return null;
      }

      public void finished()
      {
        if ( tableModel.getRowCount() > 0 )
        {
          setStateFound();
          selTable.setRowSelectionInterval( 0, 0 );
          selTable.requestFocus();
          // Es wurden Datensätze gelesen !
          String message = xxMessage.getMessage( 19, "" + tableModel.getRowCount() );
          statusBar.setText( message );
        }
        else
        {
          setStateNotFound();
          // Keine Datensätze gefunden !
          String message = xxMessage.getMessage( 17 );
          statusBar.setText( message );
        }
        getGlassPane().setVisible( false );
      }
    }; // SwingWorker

    worker.start();

  } // mnuFind_actionPerformed

  /**
   * Das Ok-Menü wurde gewählt.
   * Schlüssel der gewählten Zeile zurückgeben.
   * @param e ActionEvent
   */
  protected void mnuOk_actionPerformed( ActionEvent e )
  {
    setStateSelected();
    // Schlüssel abfüllen
    int row = selTable.getSelectedRows()[0];
    selRegadrNr = ( (Integer) tableSorterView.getValueAt( row, 0 ) ).intValue();
    mainController.getWindow().setVisible( false );
    mainController.getWindow().dispose();
  }

  //********* Menu bearbeiten *******************************************

  /**
   * Das Rückgängig-machen-Menü wurde gewählt.
   * Suchfelder löschen
   * @param e ActionEvent
   */
  protected void mnuUndo_actionPerformed( ActionEvent e )
  {
    setStateNotFound();
    txfRegadrNr.requestFocus();
    txfRegadrNr.setText( "" );
    txfRegName.setText( "" );
    txfSuchbegr.setText( "" );
    txfRegOrt.setText( "" );
    txfLandCd.setText( "" );
    txfAdrNr.setText( "" );
    rbnAlle.setSelected( true );
    rbnIndex.setSelected( true );
    cbxNurVersAdr.setSelected( false );
    cbxNurChLi.setSelected( true );
    tableModel.clear();
    statusBar.setText( " " );
  }

  //********** Menu verzweigen *********************************************

  /**
   * Das Detail-Menü wurde gewählt.
   * Daten lesen und Detailseite anzeigen.
   * @param e ActionEvent
   */
  protected void mnuDetail_actionPerformed( ActionEvent e )
  {
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.WAIT_CURSOR ) );
    if ( mode == SEARCH )
    {
      setForwardEnabled( true );
      regadrDtl = new RegadrDtl( mainController, MainRootPane.DETAIL );
    }
    else if ( mode == SEARCH_LOOKUP )
    {
      regadrDtl = new RegadrDtl( mainController, MainRootPane.DETAIL_LOOKUP );
    }
    // Schlüssel abfüllen
    int row = selTable.getSelectedRows()[0];
    regadrDtl.setKey( (Integer) tableSorterView.getValueAt( row, 0 ) );
    regadrDtl.read();
    mainController.next( regadrDtl );
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
  }

  /**
   * Das Info-Menü wurde gewählt.
   * @param e ActionEvent
   */
  protected void mnuInfo_actionPerformed( ActionEvent e )
  {
    new CustomDlgInfo( (JFrame) this.mainController.getWindow(), true ).setVisible( true );
  }

  //********** Popup-Menu **************************************************

  //********** Pane-spezifische Methoden ***********************************

  /**
   * Klick auf Zeile der Tabelle.
   * Bei Doppelclick weiterverzweigen
   * @param e MouseEvent
   */
  protected void selTable_MouseListener( MouseEvent e )
  {
    setStateFound();
    // bei Doppelclick weiterverzweigen
    if ( e.getClickCount() == 2 )
    {
      if ( mode == SEARCH )
      {
        mnuDetail_actionPerformed( null );
      }
      else if ( mode == SEARCH_LOOKUP )
      {
        mnuOk_actionPerformed( null );
      }
    }
  }

  /**
   * Falls Focus nicht mehr in der Tabelle ist, wird der Suchenknopf der Default.
   * @param e FocusEvent
   */
  protected void selTable_focusLost( FocusEvent e )
  {
    if ( !e.isTemporary() )
    {
      setDefaultButton( btnFind );
    }
  }

  /**
   * Falls der Focus wieder auf der Tabelle ist, wird der Detailknopf der Default.
   * @param e FocusEvent
   */
  protected void selTable_focusGained( FocusEvent e )
  {
    if ( mode == SEARCH )
    {
      setDefaultButton( btnDetail );
    }
    else
    {
      setDefaultButton( btnOk );
    }
  }

  /**
   * Enter-Taste in der Tabelle löst den DefaultButton aus.
   * @param e KeyEvent
   */
  protected void selTable_keyPressed( KeyEvent e )
  {
    if ( e.getKeyCode() == KeyEvent.VK_ENTER )
    {
      getDefaultButton().doClick();
      e.consume();
    }
  }

  /**
   * Setzt Menus und Buttons in den Initialzustand zurück
   * @param e Mousevent
   */
  protected void header_MouseListener( MouseEvent e )
  {
    setStateNotFound();
  }

  //********** Authorization ***************************************************

  /**
   * @return Authorization
   */
  public static String[] getAuthzSpecifications()
  {
    return new String[] { "*New    = Schreiben/RegisterAdressen", "*Detail = Lesen/RegisterAdressen", };
  }

  /**
  * initialisiert javahelp
  */
  public void initHelp()
  {
    HelpUtil.getInstance().enableHelpKey( this.getRootPane(), "adrSuchen" );

    HelpUtil.getInstance().enableHelpOnButton( btnHelp, "adrSuchen" );
    HelpUtil.getInstance().enableHelpOnButton( mnuHelp, "adrSuchen" );

    HelpUtil.getInstance().enableHelp( toolBar, "icons" );
    HelpUtil.getInstance().enableHelp( menuBar, "auswahlmenues" );
    HelpUtil.getInstance().enableHelp( txfRegadrNr, "adrSuchen.selektionskriterienregadr" );
    HelpUtil.getInstance().enableHelp( txfSuchbegr, "adrSuchen.selektionskriterienregadr" );
    HelpUtil.getInstance().enableHelp( txfRegName, "adrSuchen.selektionskriterienregadr" );
    HelpUtil.getInstance().enableHelp( txfRegOrt, "adrSuchen.selektionskriterienregadr" );
    HelpUtil.getInstance().enableHelp( txfLandCd, "adrSuchen.selektionskriterienregadr" );
    HelpUtil.getInstance().enableHelp( txfAdrNr, "adrSuchen.selektionskriterienregadr" );
    HelpUtil.getInstance().enableHelp( cbxNurChLi, "adrSuchen.selektionskriterienregadr" );
    HelpUtil.getInstance().enableHelp( cbxNurVersAdr, "adrSuchen.selektionskriterienregadr" );
    HelpUtil.getInstance().enableHelp( rbnAlle, "adrSuchen.selektionskriterienregadr" );
    HelpUtil.getInstance().enableHelp( rbnIndex, "adrSuchen.selektionskriterienregadr" );
    HelpUtil.getInstance().enableHelp( rbnNurGesperrte, "adrSuchen.selektionskriterienregadr" );
    HelpUtil.getInstance().enableHelp( rbnNurGueltige, "adrSuchen.selektionskriterienregadr" );
    HelpUtil.getInstance().enableHelp( rbnVolltext, "adrSuchen.selektionskriterienregadr" );
    HelpUtil.getInstance().enableHelp( selTable, "adrSuchen.ergebnis" );
  }
} // RegadrAwl
