package ch.ige.adr.server;

import java.util.StringTokenizer;

import javax.ejb.EJBException;

/**
 * Normalisiert die an das ValueObject(PostOrtVO) übergebenen Daten.
 * <p>
 * Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Michael Zaugg
 * @version $Id: PostOrtNorm.java,v 1.9 2007/07/03 15:20:54 nydegger Exp $
 */

public class PostOrtNorm
{
  /**
   * getOrtNorm
   * @param ort 
   * @return normalisierter Ort
   */
  public static String getOrtNorm(String ort)
  {
    return PostOrtNorm.getOrtNorm(ort, false);
  }

  /**
   * holt normalisierter Ort
   * @param ort
   * @param mitProzent
   * @return normalisierter Ort
   */
  public static String getOrtNorm(String ort, boolean mitProzent)
  {
    final String spezChar     = ("Š ,Œ ,Ÿ ,À ,Á ,Â ,Ã ,Ä ,Å ,Æ ,Ç ,È ,É ,Ê ,Ë ,Ì ,Í ,Î ,Ï ,Ð ,Ñ ,Ò ,Ó ,Ô ,Õ ,Ö ,Ø ,Ù ,Ú ,Û ,Ü ,ß ,š ,œ ,ý ");
    final String subChar      = ("S ,OE,Y ,A ,A ,A ,A ,AE,A ,AE,C ,E ,E ,E ,E ,I ,I ,I ,I ,D ,N ,O ,O ,O ,O ,OE,OE,U ,U ,U ,UE,SS,S ,OE,Y ");

    ort = ort.toUpperCase();
    ort = ort.trim();

    char zeichen;
    StringBuffer ortNorm = new StringBuffer();

    for (int i = 0; i < ort.length(); i++)
    {
      zeichen = ort.charAt(i);
      if (mitProzent && zeichen == '%')
      {
        // Prozent nicht als Sonderzeichen behandeln

        ortNorm.append(zeichen);
      }
      else if (zeichen == ' ' || !Character.isLetterOrDigit(zeichen) )
      {
        // Ende eines Wortes
        if (!ortNorm.toString().endsWith("."))
        {
          ortNorm.append('.');
        }
      }
      else
      {
        int j = spezChar.indexOf(zeichen);

        if (j == -1)
        {
            ortNorm.append(zeichen);
        }
        else
        {
            String str = subChar.substring(j, j+2);
            ortNorm.append(str.trim());
        }
      }

    }
    return ortNorm.toString();
  }
}
