package ch.ige.adr.server.test;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import ch.ige.adr.server.AdresseEpFacade;
import ch.ige.adr.server.AdresseEpFacadeHome;
import ch.ige.adr.server.AdresseFacade;
import ch.ige.adr.server.AdresseFacadeHome;
import ch.ige.util.ServiceLocator;
import ch.ige.util.vo.AdrRegadrNrVO;
import ch.ige.util.vo.RegadrVO;
import ch.ige.util.vo.VersadrVO;

/**
 * Dient zum Testen der AdresseEpFacade
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: AdresseEpFacadeTestJUnit.java,v 1.13 2007/09/10 11:46:52 nydegger Exp $
 */

public class AdresseEpFacadeTestJUnit extends TestCase
{

  private AdresseEpFacadeHome adresseEpFacadeHome = null;

  private AdresseEpFacade adresseEpFacade = null;

  private AdresseFacadeHome adresseFacadeHome = null;

  private AdresseFacade adresseFacade = null;

  /**
   * @param parName
   */
  public AdresseEpFacadeTestJUnit( String parName )
  {
    super( parName );
  }

  /**
   * suite überschreibt Klassenmethode. Gibt die eigene Klasse als Testsuite zurück
   * @return Test
   */

  public static Test suite()
  {
    return new TestSuite( AdresseEpFacadeTestJUnit.class );
  }

  /**
   * Test der Registeradresse
   */
  /*
   public void testCreateRegadrEp()
   {
   getFacade();
   try
   {
   int anzahl;

   // Create neue Regadr
   RegadrVO regadrVO = new RegadrVO();
   regadrVO.blandCd = "CH";
   regadrVO.regName = "EP-Band nur reg zwei";
   regadrVO.regStrasse = "test Strasse";
   regadrVO.regOrt = "3312 Fraubrunnen";
   regadrVO.upRegOrt = regadrVO.regOrt.toUpperCase();
   regadrVO.upVerzName = "EP-BAND";
   regadrVO.regadrNr = adresseEpFacade.createRegadrEp(regadrVO);

   // Selektieren der neuen Regadr
   RegadrVO regadrResultVO = adresseFacade.getRegadr(regadrVO.regadrNr);

   assertEquals("1. Test - regadrNr: ", regadrVO.regadrNr, regadrResultVO.regadrNr);
   assertEquals("2. Test - blandCd: ", regadrVO.blandCd, regadrResultVO.blandCd);
   assertEquals("3. Test - regName: ", regadrVO.regName, regadrResultVO.regName);
   assertEquals("4. Test - regStrasse: ", regadrVO.regStrasse, regadrResultVO.regStrasse);
   assertEquals("5. Test - regOrt: ", regadrVO.regOrt, regadrResultVO.regOrt);
   assertEquals("6. Test - upRegOrt: ", regadrVO.upRegOrt, regadrResultVO.upRegOrt);
   assertEquals("7. Test - upVerzName: ", regadrVO.upVerzName, regadrResultVO.upVerzName);

   }
   catch (Exception e)
   {
   fail(e.toString());
   }
   }
   */
  /**
   * Test der Registeradresse und Versandadresse
   */
  public void _testCreateRegadrVersadrEp()
  {
    testGetFacade();
    try
    {
      for ( int i = 1; i < 2; i++ )
      {
        System.out.println( "i = " + i );
        // Create neue Regadr
        RegadrVO regadrVO = new RegadrVO();
        regadrVO.setBlandCd( "US" );
        regadrVO.setRegName( "THE GOVERNMENT OF THE UNITED STATES OF AMERICA, as represented by THE SECRETARY OF THE DEPARTMENT OF HEALTH AND HUMAN SERVICES" );
        regadrVO.setRegStrasse( "c/o National Institutes of Health,\n" + "Office of Technology Transfer,\n" + "6011 Executive Boulevard,\n" + "Suite 325" );
        regadrVO.setRegOrt( "Rockville, MD 20852-3804" );
        regadrVO.setUpRegOrt( regadrVO.getRegOrt().toUpperCase() );
        regadrVO.setUpVerzName( "EP-BAND" );
        AdrRegadrNrVO adrRegadrNrVO = adresseEpFacade.createRegadrVersadrEp( regadrVO, "D" );
        regadrVO.setRegadrNr( adrRegadrNrVO.regadrNr );
        regadrVO.setAdrNr( adrRegadrNrVO.adrNr );

        // Selektieren der neuen Regadr
        RegadrVO regadrResultVO = adresseFacade.getRegadr( regadrVO.getRegadrNr() );

        assertEquals( "1. Test - regadrNr: ", regadrVO.getRegadrNr(), regadrResultVO.getRegadrNr() );
        assertEquals( "2. Test - blandCd: ", regadrVO.getBlandCd(), regadrResultVO.getBlandCd() );
        assertEquals( "3. Test - regName: ", regadrVO.getRegName(), regadrResultVO.getRegName() );
        assertEquals( "4. Test - regStrasse: ", regadrVO.getRegStrasse(), regadrResultVO.getRegStrasse() );
        assertEquals( "5. Test - regOrt: ", regadrVO.getRegOrt(), regadrResultVO.getRegOrt() );
        assertEquals( "6. Test - upRegOrt: ", regadrVO.getUpRegOrt(), regadrResultVO.getUpRegOrt() );
        // upVerzName muss nicht gleich sein, da ev. eine existierende Regadr gefunden wird
        // assertEquals("7. Test - upVerzName: ", regadrVO.upVerzName, regadrResultVO.upVerzName);

        // Selektieren der Versandadresse
        VersadrVO versadrResultVO = adresseFacade.getVersadr( adrRegadrNrVO.adrNr );
      }
    }
    catch ( Exception e )
    {
      fail( e.toString() );
    }
  }

  /**
   * Test der Registeradresse und Versandadresse
   */
  public void _testCreateRegadrVersadrEpJeory()
  {
    testGetFacade();
    try
    {
      for ( int i = 1; i < 2; i++ )
      {
        System.out.println( "i = " + i );
        // Create neue Regadr
        RegadrVO regadrVO = new RegadrVO();
        regadrVO.setBlandCd( "GB" );
        regadrVO.setRegName( "Jeory, C.P." );
        regadrVO.setRegStrasse( "t/a Premier Hydraulics & Pneumatics,\n" + "Unit 1,\n" + "Murray Street" );
        regadrVO.setRegOrt( "Preston, PR1 7HY" );
        regadrVO.setUpRegOrt( regadrVO.getRegOrt().toUpperCase() );
        regadrVO.setUpVerzName( "EP-BAND" );
        // TODO regadrNr ist die Gleiche mit  "Jeory, C.P." und "Jeory, J."
        AdrRegadrNrVO adrRegadrNrVO = adresseEpFacade.createRegadrVersadrEp( regadrVO, "D" );
        regadrVO.setRegadrNr( adrRegadrNrVO.regadrNr );
        regadrVO.setAdrNr( adrRegadrNrVO.adrNr );

        // Selektieren der neuen Regadr
        RegadrVO regadrResultVO = adresseFacade.getRegadr( regadrVO.getRegadrNr() );

        assertEquals( "1. Test - regadrNr: ", regadrVO.getRegadrNr(), regadrResultVO.getRegadrNr() );
        assertEquals( "2. Test - blandCd: ", regadrVO.getBlandCd(), regadrResultVO.getBlandCd() );
        assertEquals( "3. Test - regName: ", regadrVO.getRegName(), regadrResultVO.getRegName() );
        assertEquals( "4. Test - regStrasse: ", regadrVO.getRegStrasse(), regadrResultVO.getRegStrasse() );
        assertEquals( "5. Test - regOrt: ", regadrVO.getRegOrt(), regadrResultVO.getRegOrt() );
        assertEquals( "6. Test - upRegOrt: ", regadrVO.getUpRegOrt(), regadrResultVO.getUpRegOrt() );
        // upVerzName muss nicht gleich sein, da ev. eine existierende Regadr gefunden wird
        // assertEquals("7. Test - upVerzName: ", regadrVO.upVerzName, regadrResultVO.upVerzName);

        // Selektieren der Versandadresse
        VersadrVO versadrResultVO = adresseFacade.getVersadr( adrRegadrNrVO.adrNr );
      }
    }
    catch ( Exception e )
    {
      fail( e.toString() );
    }
  }

  public void _testCreateRegadrVersadrEpGrossSchreibung()
  {
    testGetFacade();
    try
    {
      // Create neue Regadr
      RegadrVO regadrVO = new RegadrVO();
      regadrVO.setBlandCd( "JP" );
      regadrVO.setRegName( "HUGO-CANON BLUBBER KABUSHIKI KAISHA" );
      regadrVO.setRegStrasse( "30-2, Shimomaruko 3-chome, \n" + "Ohta-ku" );
//      regadrVO.setRegStrasse( "t/a Premier Hydraulics & Pneumatics,\n" + "Unit 1,\n" + "Murray Street" );
      regadrVO.setRegOrt( "Tokyo" );
      regadrVO.setUpRegOrt( regadrVO.getRegOrt().toUpperCase() );
      regadrVO.setUpVerzName( "CANON BLUBBER KABUSHIKI KAISHA" );
      AdrRegadrNrVO adrRegadrNrVO = adresseEpFacade.createRegadrVersadrEp( regadrVO, "D" );
      regadrVO.setRegadrNr( adrRegadrNrVO.regadrNr );
      regadrVO.setAdrNr( adrRegadrNrVO.adrNr );

      // Selektieren der neuen Regadr
      RegadrVO regadrResultVO = adresseFacade.getRegadr( regadrVO.getRegadrNr() );

      assertEquals( "1. Test - regadrNr: ", regadrVO.getRegadrNr(), regadrResultVO.getRegadrNr() );
      assertEquals( "2. Test - blandCd: ", regadrVO.getBlandCd(), regadrResultVO.getBlandCd() );
      assertEquals( "3. Test - regName: ", regadrVO.getRegName(), regadrResultVO.getRegName() );
      assertEquals( "4. Test - regStrasse: ", regadrVO.getRegStrasse(), regadrResultVO.getRegStrasse() );
      assertEquals( "5. Test - regOrt: ", regadrVO.getRegOrt(), regadrResultVO.getRegOrt() );
      assertEquals( "6. Test - upRegOrt: ", regadrVO.getUpRegOrt(), regadrResultVO.getUpRegOrt() );
      // upVerzName muss nicht gleich sein, da ev. eine existierende Regadr gefunden wird
      // assertEquals("7. Test - upVerzName: ", regadrVO.upVerzName, regadrResultVO.upVerzName);

      // Selektieren der Versandadresse
      VersadrVO versadrResultVO = adresseFacade.getVersadr( adrRegadrNrVO.adrNr );
      System.out.println("test");
    }
    catch ( Exception e )
    {
      fail( e.toString() );
    }
  }

  /**
   * Test der Registeradresse und Versandadresse
   */
  public void _testCreateRegadrVersadrEpKüsu()
  {
    testGetFacade();
    try
    {
      for ( int i = 1; i < 2; i++ )
      {
        System.out.println( "i = " + i );
        // Create neue Regadr
        RegadrVO regadrVO = new RegadrVO();
        regadrVO.setBlandCd( "GB" );
        regadrVO.setRegName( "Jeory, C.P." );
        regadrVO.setRegStrasse( "t/a Premier Hydraulics & Pneumatics,\n" + "Unit 1,\n" + "Murray Street" );
        regadrVO.setRegOrt( "Preston, PR1 7HY" );
        regadrVO.setUpRegOrt( regadrVO.getRegOrt().toUpperCase() );
        regadrVO.setUpVerzName( "EP-BAND" );
        // TODO regadrNr ist die Gleiche mit  "Jeory, C.P." und "Jeory, J."
        AdrRegadrNrVO adrRegadrNrVO = adresseEpFacade.createRegadrVersadrEp( regadrVO, "D" );
        regadrVO.setRegadrNr( adrRegadrNrVO.regadrNr );
        regadrVO.setAdrNr( adrRegadrNrVO.adrNr );

        // Selektieren der neuen Regadr
        RegadrVO regadrResultVO = adresseFacade.getRegadr( regadrVO.getRegadrNr() );

        assertEquals( "1. Test - regadrNr: ", regadrVO.getRegadrNr(), regadrResultVO.getRegadrNr() );
        assertEquals( "2. Test - blandCd: ", regadrVO.getBlandCd(), regadrResultVO.getBlandCd() );
        assertEquals( "3. Test - regName: ", regadrVO.getRegName(), regadrResultVO.getRegName() );
        assertEquals( "4. Test - regStrasse: ", regadrVO.getRegStrasse(), regadrResultVO.getRegStrasse() );
        assertEquals( "5. Test - regOrt: ", regadrVO.getRegOrt(), regadrResultVO.getRegOrt() );
        assertEquals( "6. Test - upRegOrt: ", regadrVO.getUpRegOrt(), regadrResultVO.getUpRegOrt() );
        // upVerzName muss nicht gleich sein, da ev. eine existierende Regadr gefunden wird
        // assertEquals("7. Test - upVerzName: ", regadrVO.upVerzName, regadrResultVO.upVerzName);

        // Selektieren der Versandadresse
        VersadrVO versadrResultVO = adresseFacade.getVersadr( adrRegadrNrVO.adrNr );
      }
    }
    catch ( Exception e )
    {
      fail( e.toString() );
    }
  }

  /**
   * Holt die Facade.
   */
  public void testGetFacade()
  {
    try
    {
      // AdresseEpFacade
      if ( adresseEpFacadeHome == null )
      {
        adresseEpFacadeHome = (AdresseEpFacadeHome) ServiceLocator.getInstance().getHome( AdresseEpFacadeHome.JNDI_NAME, AdresseEpFacadeHome.class );
      }
      if ( adresseEpFacade == null )
      {
        adresseEpFacade = adresseEpFacadeHome.create();
      }
      // AdresseFacade
      if ( adresseFacadeHome == null )
      {
        adresseFacadeHome = (AdresseFacadeHome) ServiceLocator.getInstance().getHome( AdresseFacadeHome.JNDI_NAME, AdresseFacadeHome.class );
      }
      if ( adresseFacade == null )
      {
        adresseFacade = adresseFacadeHome.create();
      }

    }
    catch ( Exception ex )
    {
      fail( ex.toString() );
    }
  }

  /**
   * Main Methode
   * @param args
   */
  public static void main( String[] args )
  {
    junit.textui.TestRunner.run( suite() );
  }
}
