package ch.ige.art.client.art;

import java.awt.*;
import javax.swing.*;

import ch.ige.main.client.*;


/**
 * <p>Mediator für ArtikelLight-Wizard </p>
 * <p>Beschreibung: Wizard für das Erfassen und Mutieren der Artikel-Texte
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Organisation: Institut für Geistiges Eigentum</p>
 * @author Anita Rueegsegger
 * @version $Id: ArtWizardLimited.java,v 1.4 2007/12/17 16:10:24 ruegsegger Exp $
 */

public class ArtWizardLimited extends ArtWizardMediator
{
  /**
   * Konstruktor
   * @param parent aufrufendes Frame
   */
  public ArtWizardLimited(Frame parent)
  {
    super(parent);
  }

  /**
   * Konstruktor
   * @param parent aufrufender Dialog
   */
  public ArtWizardLimited(Dialog parent)
  {
    super(parent);
  }


  /**
   * Initialisierung
   */
  protected void initializePanel()
  {
    alPanel.add( new WizardMediator.WizardPanel( pnlArtTexte, true ) );
    maxPanel = alPanel.size();
    title = "Texte";
  }


  /**
   * Artikeltexte mutieren
   * @param artNr Artikel-Nummer
   * @return true = fertiggestellt, false = abgebrochen
   */
  public boolean editArt(String artNr)
  {
    read(artNr);

    artikelGuiAVO.status = "U";
    pnlArtTexte.setData(artikelGuiAVO);
    init();
    return finish;
  }

  /**
   * überschreibt protected Methode der Oberklasse</br>
   * Speichert Daten des Panels in VO und in Datenbank
   * fehler == null --> keine Fehler Artikel kann gespeicher werden
   * fehler.equals("") --> Fehler aufgetreten, und angezeigt, Panel nicht wechseln
   * anderenfalls den im fehler enthaltenen String anzeigen
   *
   * @return true  - nächstes Panel anzeigen<br>
   *         false - auf aktuellem Panel bleiben, z.B. wegen Validierungsfehler
   */
  public boolean finish()
  {
    String fehler = pnlArtTexte.validForward(); // Daten validieren

    if ( fehler != null )
    {
      if ( !fehler.equals( "" ) )
      {
        JOptionPane.showMessageDialog( null, fehler, "Ungültige Eingabe",
                                       JOptionPane.INFORMATION_MESSAGE );
      }
      return finish = false;
    }

    artikelGuiAVO = pnlArtTexte.getData(); //Daten aus Panel holen und in artikelGuiAVO abspeichern

    return super.finish();
  }
}

