package ch.ige.art.client.util.editoren;

import javax.swing.*;

import ch.ige.art.client.util.verifier.DoubleVerifier;


/**
 * <p>Überschrift: Editor für Preiseingabe</p>
 * <p>Beschreibung: Editor für Preiseingabe innerhalb einer Tabelle, Validierung auf double-Wert</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Organisation: Institut für Geistiges Eigentum</p>
 * @author Anita Rueegsegger
 * @version $Id: TblCellDoubleEditor.java,v 1.4 2006/12/13 10:08:31 ruegsegger Exp $
 */
public class TblCellDoubleEditor extends DefaultCellEditor
{

  public TblCellDoubleEditor(JTextField tf)
  {
    super(tf);
  }

  /**
   * Beendet Editiermodus der Zelle
   * @return boolean true  - Zelle beinhaltet gültigen Wert
   *                 false - Zelle beinhaltet ungültigen Wert
   */
  public boolean stopCellEditing()
  {
    DoubleVerifier verifier = new DoubleVerifier();

    if (!verifier.verify(editorComponent))
    {
      String message  = "Wert entspricht nicht dem Eingabeformat 0.00";

      JOptionPane.showMessageDialog
      (null, message, "Ungültige Eingabe", JOptionPane.INFORMATION_MESSAGE);
      return false;
    }
    else
    {
      return super.stopCellEditing();
    }
  }
}


