package ch.ige.art.server.test;

import java.util.List;

import org.apache.log4j.BasicConfigurator;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import ch.ige.art.server.ArtikelDelegate;
import ch.ige.art.vo.ArtikelGuiAVO;
import ch.ige.art.vo.ArtikelSelKritVO;
import ch.ige.util.server.DBHelper;

/**
 * Test des BusinessDelegate
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Stefan Nydegger
 * @version $Id: ArtikelDelegateTest.java,v 1.6 2007/07/09 05:52:43 locher Exp $
 */

public class ArtikelDelegateTest extends TestCase
{
  private ArtikelDelegate ad = null;
  
  static
  {
    // init log4j
    BasicConfigurator.configure();
  }
  
  public ArtikelDelegateTest( String parName )
  {
    super( parName );
  }


  /**
   * Selektieren eines einzelnen Artikels
   */
  public void testGetArtikel()
  {
    try
    {
      System.out.println( "TEST GET ARTIKEL" );
      ArtikelGuiAVO artikelGuiAVO = ad.getInstance().getArtikel( "10" );
      if ( artikelGuiAVO == null )
      {
        fail( "GET ARTIKEL: Datensatz existiert nicht" );
      }

      assertTrue( "1. Test - artNr: ", artikelGuiAVO.artNr.equals( "10" ) );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.toString() );
    }
  }


  /**
   * Selektieren von mehreren Artikeln nach Suchkriterien
   */
  public void testFindArtikel()
  {
    try
    {
      System.out.println( "TEST FIND ARTIKEL" );
      ArtikelSelKritVO artikelSelKritVO = new ArtikelSelKritVO();
      artikelSelKritVO.artNr="18000-19000";

      List list = ad.getInstance().findArtikel( artikelSelKritVO );
      assertTrue( "1. Test - Anzahl Artikel: ", list.size() > 50 );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.toString() );
    }
  }


  public void testSetArtikel()
  {
    try
    {
      System.out.println( "TEST SET ARTIKEL" );
      ArtikelGuiAVO artikelGuiAVO = ad.getInstance().getArtikel( "10" );
      if ( artikelGuiAVO == null )
      {
        fail( "GET ARTIKEL: Datensatz existiert nicht" );
      }

      ad.getInstance().setArtikel( artikelGuiAVO, "ArtikelDelegateTest#testSetArtikel" );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.toString() );
    }
  }
}

