package ch.ige.art.util;

import java.util.List;

import javax.naming.InitialContext;

import org.apache.log4j.Logger;

import ch.ige.statistikartikel.server.StatistikArtikel;
import ch.ige.statistikartikel.server.StatistikArtikelHome;
import ch.ige.statistikartikel.util.ArticleStatisticInfoVO;
import ch.ige.statistikweb.statistikartikel.util.NumberRangeList;

/**
 * 
 *
 * <p>Copyright (c) 2008, Swiss Federal Institute of Intellectual Property</p>
 * @author   ruegsegger
 * @version  $Id: StatistikDelegate.java,v 1.3 2008/05/07 17:15:19 ruegsegger Exp $
 */
public class StatistikDelegate
{
  private static final Logger LOG = Logger.getLogger( StatistikDelegate.class );

  private static StatistikDelegate statistikDelegate = null;

  private StatistikArtikel statistik;

  private static NumberRangeList rangeArticlesInStatistic;

  private StatistikDelegate() throws Throwable
  {
    LOG.info( "lookup statistik" );

    InitialContext context = new InitialContext();

    StatistikArtikelHome home = (StatistikArtikelHome) context.lookup( StatistikArtikelHome.JNDI_NAME );
    statistik = home.create();

    rangeArticlesInStatistic = statistik.getArticlesInUse();

    LOG.info( "range of articles in statistic loaded" );
  }

  /**
     * Gibt die einzige Instanz zurück (Singleton)
     * @return Referenz auf XxDomain
     */
  public static StatistikDelegate getInstance() throws Throwable
  {
    if ( statistikDelegate == null )
    {
      statistikDelegate = new StatistikDelegate();
    }
    return statistikDelegate;
  }

  public NumberRangeList getRangeOfArticlesInStatistic()
  {
    return rangeArticlesInStatistic;
  }

  public List<ArticleStatisticInfoVO> getStatisticsForArticle( int article ) throws Exception
  {
    return statistik.getStatisticsForArticle( article );
  }

}
