package ch.ige.art.vo;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * Überschrift:   ArtpreisVO
 * Beschreibung:  Value Object der Tabelle Artpreis
 * Copyright:     Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * Organisation:  IGE
 * @author        Stefan Nydegger
 * @version $Id: ArtpreisVO.java,v 1.8 2008/06/25 13:58:04 ruegsegger Exp $
 */

public class ArtpreisVO implements Serializable
{
  public String artNr = null;

  public String mengeinh = "ANZ";

  public String artpreisartCd = "NP";

  public Date gueltigAb = null;

  public BigDecimal preis = new BigDecimal( 0 );

  public Integer pro = new Integer( 1 );

  public String kennzeichen = null;

  public String erstBen = null;

  public Date erstDat = null;

  public String geaendBen = null;

  public Date geaendDat = null;

  public String uVersion = "!";

  public String status = "";

  //----------------------------------------------------------------------------
  // methods
  //----------------------------------------------------------------------------

  @Override
  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append( "  artNr               = <" + this.artNr + "> \n" );
    buf.append( "  mengeinh            = <" + this.mengeinh + "> \n" );
    buf.append( "  artpreisartCd       = <" + this.artpreisartCd + "> \n" );
    buf.append( "  gueltigAb           = <" + this.gueltigAb + "> \n" );
    buf.append( "  preis               = <" + this.preis + "> \n" );
    buf.append( "  pro                 = <" + this.pro + "> \n" );
    buf.append( "  kennzeichen         = <" + this.kennzeichen + "> \n" );
    buf.append( "  erstBen             = <" + this.erstBen + "> \n" );
    buf.append( "  erstDat             = <" + this.erstDat + "> \n" );
    buf.append( "  geaendBen           = <" + this.geaendBen + "> \n" );
    buf.append( "  geaendDat           = <" + this.geaendDat + "> \n" );
    buf.append( "  uVersion            = <" + this.uVersion + "> \n" );
    buf.append( "  status              = <" + this.status + "> \n" );

    return buf.toString();
  }
}
