package ch.ige.epband.clientneu.test;

import ch.ige.epband.clientneu.IpcSymbol;
import junit.framework.TestCase;


/**
 * Test der Klasse IpcSymbol
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: IpcSymbolTest.java,v 1.6 2006/12/07 07:12:38 wild Exp $
 */
public class IpcSymbolTest extends TestCase
{
/**
 * Konstruktor
 * @param s
 */
  public IpcSymbolTest( String s )
  {
    super( s );
  }

  /** 
   * Prüfung des richtigen Mappings der alten Darstellung auf die neue.
   *
   */
  public void test00()
  {
    String ipcSymb = null;
    String expectedValue = null;

    ipcSymb = " 7A 61K  35/76   A";
    expectedValue = "A61K003576";
    checkIpcSymbol( ipcSymb, expectedValue, true );

    ipcSymb = " 7A 61K  48/00   B";
    expectedValue = "A61K004800";
    checkIpcSymbol( ipcSymb, expectedValue, true );

    ipcSymb = " 7H 04N   5/50   B";
    expectedValue = "H04N000550";
    checkIpcSymbol( ipcSymb, expectedValue, true );

    ipcSymb = " 7F 02M  31/125  B";
    expectedValue = "F02M0031125";
    checkIpcSymbol( ipcSymb, expectedValue, true );

    ipcSymb = " 7C 12P  21/02   B";
    expectedValue = "C12P002102";
    checkIpcSymbol( ipcSymb, expectedValue, true );

    ipcSymb = "0101:0101";
    expectedValue = "";
    checkIpcSymbol( ipcSymb, expectedValue, false );

    ipcSymb = null;
    expectedValue = "";
    checkIpcSymbol( ipcSymb, expectedValue, false );
  }


  private void checkIpcSymbol( String ipcSymb, String expectedValue, boolean valid )
  {
    try
    {
      String ipcSymbol = new IpcSymbol( ipcSymb ).getIpcSymbol();
      assertEquals( expectedValue, ipcSymbol );
    }
    catch( Exception ex )
    {
      if( valid )
      {
        fail();
        ex.printStackTrace();
      }
    }
  }
}
