package ch.ige.epband.server.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import ch.ige.util.log.LogLevelHelper;
import ch.ige.util.server.DBHelper;

/**
 * DataAccessObject für BLAND
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author Stephan Madl, Michael Zaugg
 * @version $Id: BlandDAO.java,v 1.11 2008/02/28 14:58:03 wild Exp $
 */

public class BlandDAO
{

  /**
   * Liest alle BLänder aus BLAND
   *
   * @return  ArrayList BlandWorkAVO
   *
   * @exception SQLException
   */

  public ArrayList<String> getAllBland() throws SQLException
  {
    Connection con = null;
    PreparedStatement ps = null;
    String query = null;
    ResultSet rs = null;
    ArrayList<String> blandWork = new ArrayList<String>();

    try
    {
      con = DBHelper.getConnection( DBHelper.BAGIS );
      query = "SELECT trim(bland_cd) bland_cd " + "FROM bland " + "ORDER BY 1 ";
      ps = con.prepareStatement( query );
      rs = ps.executeQuery();

      while ( rs.next() )
      {
        blandWork.add( rs.getString( "bland_cd" ) );
      }
    }
    catch ( SQLException ex )
    {
      LogLevelHelper.log( ex, BlandDAO.class, query );
      throw ex;
    }
    finally
    {
      DBHelper.close( ps, con );
    }
    return blandWork;
  }

}
