package ch.ige.epband.server.dao;

import java.sql.*;

import ch.ige.epband.vo.EreigTxtVO;
import ch.ige.util.log.LogLevelHelper;
import ch.ige.util.server.DBHelper;


/**
 * <p>Überschrift: DataAccess Object für EreigTxt</p>
 * <p>Beschreibung:</p>
 * <p>Copyright: Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum</p>
 * <p>Organisation: IGE</p>
 * @author Martin Trachsel
 * @version $Id: EreigTxtDAO.java,v 1.11 2006/12/18 14:45:16 wild Exp $
 */

public class EreigTxtDAO
{

  /**
   * Ereig-text einfügen
   * @param vo
   * @return int
   * @throws SQLException
   */
  public int insert( EreigTxtVO vo ) throws SQLException
  {
    Connection con = null;
    PreparedStatement ps = null;
    String query = null;

    try
    {
      con = DBHelper.getConnection( DBHelper.BAGIS );
      query =
          "INSERT INTO ereig_txt (" +
          "schutit_key, " +
          "ereig_idat, " +
          "ereig_txt_cd, " +
          "ereig_txt, " +
          "version ) " +
          "VALUES ( ?, ?, ?, ?, ? ) ";
      ps = con.prepareStatement( query );

      ps.setInt( 1, vo.schutitKey );
      ps.setInt( 2, vo.ereigIdat );
      ps.setInt( 3, vo.ereigTxtCd );
      ps.setString( 4, vo.ereigTxt );
      ps.setInt( 5, vo.version );

      return ps.executeUpdate();
    }
    catch( SQLException ex )
    {
      LogLevelHelper.log( ex, EreigTxtDAO.class, query + vo.toString() );
      throw ex;
    }
    finally
    {
      DBHelper.close( ps, con );
    }
  }
}

