package ch.ige.epband.server.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

import ch.ige.epband.vo.SchutitRegadrVO;
import ch.ige.util.log.LogLevelHelper;
import ch.ige.util.server.DBHelper;

/**
 * <p>Überschrift:  Dataacess Object für schutitregadr</p>
 * <p>Beschreibung: </p>
 * <p>Copyright:    Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum</p>
 * <p>Organisation: IGE</p>
 * @author          Martin Trachsel
 * @version         $Id: SchutitRegadrDAO.java,v 1.10 2008/03/10 15:57:10 wild Exp $
 */

public class SchutitRegadrDAO
{

  /**
   * Kreiert ein schutit_regadr
   * @param vo Value Object mit den Daten für schutit_regadr
   * @return int Number of inserted Rows
   * @throws SQLException
   */
  public int insert( SchutitRegadrVO vo ) throws SQLException
  {
    Connection con = null;
    PreparedStatement ps = null;
    String query = null;
    try
    {
      con = DBHelper.getConnection( DBHelper.BAGIS );
      query = "INSERT INTO schutit_regadr (" + "schutit_key, " + "schutadr_lnr, " + "regadr_nr, " + "schutit_typ, " + "adr_rolle_cd, " + "von_ereig_idat, "
          + "reg_stat) " + "values (?, ?, ?, ?, ?, ?, ?) ";
      ps = con.prepareStatement( query );
      ps.setInt( 1, vo.schutitKey );
      ps.setInt( 2, vo.schutadrLnr );
      ps.setInt( 3, vo.regadrNr );
      ps.setInt( 4, vo.schutitTyp );
      ps.setInt( 5, vo.adrRolleCd );
      ps.setInt( 6, vo.vonEreigIdat );
      ps.setInt( 7, vo.regStat );

      return ps.executeUpdate();
    }
    catch ( SQLException ex )
    {
      LogLevelHelper.log( ex, SchutitRegadrDAO.class, query + vo.toString() );
      throw ex;
    }
    finally
    {
      DBHelper.close( ps, con );
    }
  }
}
