package ch.ige.epband.vo;

import java.io.Serializable;
import java.util.Date;

/**
 * Überschrift:   IpcVO
 * Beschreibung:  IpcVO ist das VO der Tabelle Ipc.
 * Copyright:     Copyright (c) 2002
 * Organisation:  IGE
 * @author       Stephan Madl
 * @version      $Id: IpcVO.java,v 1.12 2008/05/22 15:53:18 ruegsegger Exp $
 */

public class IpcVO implements Serializable
{
  /**
   *  Defaultwert für die serialVersionUID
   */
  private static final long serialVersionUID = 1L;

  public static final String ZUSATZ_CLASSIFICATION = "K"; //for classification purpose

  public static final String ZUSATZ_INDEXING = "I"; //for indexing purpose

  public static final String ZUSATZ_DOUBLE = "D"; //for both classification and indexing purpose

  public String ipcSymb = null; // not nullable

  public String zusatz = null; // not nullable

  public Date gueltigVon = null; // not nullable

  public Date gueltigBis = null;

  public String classLevel = null;

  public String corePred = null;

  public int version = 0;

  /**
   * Gibt den Inhalt des ValueObject IpcVO zurück
   * @return Inhalt von IpcVO
   */
  @Override
  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append( "  ipcSymb          = <" + this.ipcSymb + ">\n" );
    buf.append( "  zusatz           = <" + this.zusatz + ">\n" );
    buf.append( "  gueltigVon       = <" + this.gueltigVon + ">\n" );
    buf.append( "  gueltigBis       = <" + this.gueltigBis + ">\n" );
    buf.append( "  classLevel       = <" + this.classLevel + ">\n" );
    buf.append( "  corePred         = <" + this.corePred + ">\n" );
    buf.append( "  version          = <" + this.version + ">\n" );

    return buf.toString();
  }
}
