package ch.ige.image;

import java.nio.ByteBuffer;

/**
 * Dummy ImageFactory.
 * Only return wrappers around the byte arrays.
 * <p>
 * Copyright (c) 2005, Swiss Federal Institute of Intellectual Property
 *
 * @see ch.ige.image.EncodedImageWrapper
 * @see ch.ige.imagehandler.proxy.ProxyingImageHandler
 * 
 * @author    Michael Locher
 * @version   $Id: ImageFactoryWrapOnly.java,v 1.7 2009/03/19 13:26:22 locher Exp $
 */
public class ImageFactoryWrapOnly extends AbstractImageFactory implements ImageFactory
{

  /* 
   * @see ch.ige.image.EncodedImageWrapper
   * @see ch.ige.image.ImageFactory#loadBytes(byte[])
   */
  @Override
  public EncodedImage loadBytes( ByteBuffer imageData ) throws ImageException
  {
    return new EncodedImageWrapper( imageData, null );
  }

}
