package ch.ige.imagehandler.test;

import java.net.URL;

import junit.framework.TestCase;

import org.apache.log4j.BasicConfigurator;

import ch.ige.imagehandler.profile.Profile;
import ch.ige.imagehandler.profile.ProfileFactory;

/**
 * Test Profile Factory.
 * <p>
 * Copyright (c) 2005, Swiss Federal Institute of Intellectual Property
 *
 * @author Michael Locher
 * @version $Id: ProfileFactoryTest.java,v 1.9 2007/05/30 16:31:10 locher Exp $
 */
public class ProfileFactoryTest extends TestCase
{

  public ProfileFactoryTest(String name)
  {
    super(name);
  }

  public static URL getProfile()
  {
    String profile = "test_profile.xml";
    return ProfileFactoryTest.class.getResource(profile);
  }

  public static URL getDemoProfile()
  {
    String profile = "demo_profile.xml";
    return ProfileFactoryTest.class.getResource(profile);
  }

  public void testParseProfile() throws Exception
  {
    Profile p = ProfileFactory.createFromXML(ProfileFactoryTest.getProfile());
    assertNotNull(p);
    assertEquals("300", p.getEnvironmentValue(Profile.DEFAULT_DPI_NAME));
  }

  public void testParseDemoProfile() throws Exception
  {
    Profile p = ProfileFactory.createFromXML(ProfileFactoryTest.getDemoProfile());
    assertNotNull(p);
    assertEquals("300", p.getEnvironmentValue(Profile.DEFAULT_DPI_NAME));
  }

  public static void main(String[] args)
  {
    BasicConfigurator.configure();
    junit.textui.TestRunner.run(ProfileFactoryTest.class);
  }

}
