package ch.ige.ipcloadscheme.client.file;

import java.util.Date;
import java.util.Locale;

import ch.ige.ipcloadscheme.client.SchemeProperties;

/**
 * Zip-Datei welche auf dem Download-Server bereitgestellt wird
 * beinhaltet XML mit Textinformationen
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version Id:
 */
public class TextZipFile extends HttpFile
{
  public TextZipFile( Date processDate, Locale language )
  {
    super( SchemeProperties.getInstance().getProperty( SchemeProperties.TEXT_PATHNAME, language, processDate ), processDate );

    this.url = SchemeProperties.getInstance().getProperty( SchemeProperties.DOWNLOAD_URL_TEXT, language, processDate );
    this.contentType = "application/zip";
  }
}
