package ch.ige.ipcloadscheme.client.image.test;

import java.util.Arrays;
import java.util.Date;
import java.util.Locale;

import ch.ige.ipcloadscheme.client.IPCLoad.FileType;
import ch.ige.ipcloadscheme.client.file.ImageZipFile;
import ch.ige.ipcloadscheme.client.image.FiguresProcess;
import ch.ige.ipcloadscheme.client.test.ClientTestCase;
import ch.ige.ipcloadscheme.client.transfer.Transfer;
import ch.ige.util.date.DateConverter;

/**
 * Testcase Klasse FiguresProcess
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: TestFigureProcess.java,v 1.7 2008/07/01 06:27:02 lewis_lee Exp $
 */

public class TestFigureProcess extends ClientTestCase
{
  private FiguresProcess figuresProcess;

  Date processDate;

  public TestFigureProcess( String s )
  {
    super( s );
  }

  public void setUp() throws Exception
  {
    processDate = DateConverter.stringToDate( "01.01.2006" );
    ImageZipFile file = new ImageZipFile( processDate );
    file.delete();

    Transfer transfer = new Transfer( processDate );
    transfer.process( FileType.IMG, Arrays.asList( Locale.ENGLISH ) );

    assertTrue( file.exists() );
  }

  public void test00()
  {
    try
    {
      figuresProcess = new FiguresProcess( processDate );
      figuresProcess.process();
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.toString() );
    }

  }
}
