package ch.ige.ipcloadscheme.client.text.test;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.Locale;

import ch.ige.ipcloadscheme.client.test.ClientTestCase;
import ch.ige.ipcloadscheme.client.text.IpcKlassenParser;

/**
 * Test Klasse IpcKlassenParser
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: TestIpcKlassenParser.java,v 1.11 2008/07/01 06:27:02 lewis_lee Exp $
 */
public class TestIpcKlassenParser extends ClientTestCase
{

  public TestIpcKlassenParser( String s )
  {
    super( s );
  }

  public void test()
  {
    try
    {
      IpcKlassenParser parser = new IpcKlassenParser();
      File file = new File( "C:\\jp\\projects\\ipcloadscheme\\testfiles\\ipcr_scheme_c07c.xml" );
//     File file = new File( "C:\\jp\\projects\\ipcloadscheme\\testfiles\\ipcr_scheme_de_20060101.xml");
//     File file = new File( "C:\\jp\\projects\\ipcloadscheme\\testfiles\\ipcr_scheme_de_c07c.xml" );
//      File file = new File( "C:\\Data\\scheme\\ipc_de_20060101\\ipc.xml");
//    File file = new File( "C:\\jp\\projects\\ipcloadscheme\\testfiles\\ipcr_scheme_20050708.xml" );
//    File file = new File( "C:\\jp\\projects\\ipcloadscheme\\testfiles\\ipcr_scheme.xml" );

      InputStream is = new FileInputStream( file );
      parser.parse( is, Locale.ENGLISH );
    }
    catch ( Exception ex )
    {
      System.out.println( ex );
    }
  }

  public void _test01()
  {

    try
    {
      String s = this.getFormattedId( "B27J0000000000" );
      System.out.println( s );
      s = this.getFormattedId( "B27J" );
      System.out.println( s );

      s = this.getFormattedId( "H02" );
      System.out.println( s );
      s = this.getFormattedId( "H02B0000000000" );
      System.out.println( s );
    }
    catch ( Exception ex )
    {
    }

  }

  private String getFormattedId( String ipcKlasse ) throws Exception
  {
    if ( ipcKlasse.length() > 4 && !ipcKlasse.endsWith( "0000000000" ) )
    {
      try
      {
        String group = ipcKlasse.substring( 4, 8 ) + "." + ipcKlasse.substring( 8, ipcKlasse.length() );

        // group = dfGroup.format( new Double( group ) );

        StringBuffer buffer = new StringBuffer();

        buffer.append( ipcKlasse.substring( 0, 4 ) );
        buffer.append( group.replace( '.', '/' ) );

        return buffer.toString();
      }
      catch ( Exception ex )
      {
        throw new Exception( ipcKlasse + " is not a valid ipc symbol Message: " + ex );
      }
    }
    else if ( ipcKlasse.endsWith( "0000000000" ) )
    {
      return ipcKlasse.substring( 0, 4 );
    }
    else
    {
      return ipcKlasse;
    }
  }

}
