package ch.ige.ipcloadscheme.client.text.test;

import java.util.Iterator;
import java.util.Map;
import java.util.TreeMap;

import org.apache.log4j.BasicConfigurator;

import ch.ige.ipcloadscheme.client.test.ClientTestCase;
import ch.ige.ipcloadscheme.client.text.TextStorage;
import ch.ige.ipcloadscheme.server.dao.IpcBildDAO;
import ch.ige.ipcloadscheme.vo.IpcBildVO;
import ch.ige.ipcloadscheme.vo.IpcKlasseVO;
import ch.ige.ipcloadscheme.vo.test.Testdata;
import ch.ige.util.server.DBHelper;

/**
 * Junit-Test der Klasse IpcKlasseDAO
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: TestTextStorage.java,v 1.8 2008/07/01 06:27:02 lewis_lee Exp $
 */
public class TestTextStorage extends ClientTestCase
{
  private TextStorage textStorage = new TextStorage();

  private IpcKlasseVO vo;

  public TestTextStorage( String s )
  {
    super( s );
  }

  static
  {
    BasicConfigurator.configure();
    DBHelper.setRunOnServer( false );
  }

  public void test00Create()
  {
    Map map = Testdata.getVOs();

    Iterator iter = map.entrySet().iterator();
    while ( iter.hasNext() )
    {
      Map.Entry entry = (Map.Entry) iter.next();

      IpcKlasseVO ipcKlasseVO = (IpcKlasseVO) entry.getValue();
      ipcKlasseVO.textD = "neuer Text";

      System.out.println( ipcKlasseVO.toString() );
    }
  }

  /**
   * VORSICHT
   * Dieser Test löscht alle bestehenden Daten
   */
  public void _test01Create()
  {
    System.out.println( "Test CREATE " );

    try
    {
      textStorage.createNew( Testdata.getVOs(), new TreeMap() );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.toString() );
    }
  }

  public void test02Update() throws Exception
  {
    System.out.println( "Test UPDATE " );

    // Set up
    insertTestImage();

    textStorage.alter( Testdata.getVOs(), Testdata.getBildKlasseVOs() );
  }

  private void insertTestImage() throws Exception
  {
    IpcBildDAO ipcBildDAO = new IpcBildDAO();
    IpcBildVO bildVO = Testdata.getBildVO();

    if ( !ipcBildDAO.exists( bildVO.bildname ) )
    {
      int anz = ipcBildDAO.insert( bildVO );
      assertEquals( "Check that the image was inserted", 1, anz );
    }
  }
}
