package ch.ige.ipcloadscheme.client.transfer.test;

import java.util.Date;
import java.util.Locale;

import ch.ige.ipcloadscheme.client.file.TextZipFile;
import ch.ige.ipcloadscheme.client.test.ClientTestCase;
import ch.ige.ipcloadscheme.client.transfer.Download;
import ch.ige.util.date.DateConverter;

/**
 * Testcase für Klasse HTTPConnection
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: TestDownload.java,v 1.8 2008/07/01 06:27:02 lewis_lee Exp $
 */

public class TestDownload extends ClientTestCase
{
  private Download download = new Download();

  public TestDownload( String s )
  {
    super( s );
  }

  public void testDownload()
  {
    try
    {
      Date processDate = DateConverter.stringToDate( "01.01.2006" );

      TextZipFile file = new TextZipFile( processDate, Locale.ENGLISH );
      file.delete();

      download.download( file );

      assertTrue( file.exists() );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.toString() );
    }
  }
}
