package ch.ige.ipcloadvalidity.client.process;

import java.util.Date;
import java.util.List;

import org.apache.log4j.Logger;

import ch.ige.ipcloadvalidity.server.IpcValidityDelegate;
import ch.ige.ipcloadvalidity.vo.IpcVO;
import ch.ige.ipcloadvalidity.vo.StatistikVO;
import ch.ige.ipcloadvalidity.vo.TransferVO;

public class Storage
{

  private static final Logger LOG = Logger.getLogger( ReadFile.class );
  private StatistikVO statistikVO = new StatistikVO();
  private boolean errorOccured = false;

  public Storage()
  {
  }


  public boolean isErrorOccured()
  {
    return errorOccured;
  }



  public StatistikVO save( List updates, List inserts, Date validTo )
  {
    processUpdate( updates );
    processInsert( inserts, validTo );

    return statistikVO;
  }

  private void processUpdate( List updates )
  {
    LOG.info( " process updates size " + updates.size() );

    for ( int i = 0; i < updates.size(); i++ )
    {
      update( ( IpcVO ) updates.get( i ) );
    }
  }

  private void processInsert( List inserts, Date validTo )
  {
    LOG.info( "process inserts size " + inserts.size() );
    for ( int i = 0; i < inserts.size(); i++ )
    {
      insert( ( IpcVO ) inserts.get( i ), validTo );
    }
  }

  private void insert( IpcVO ipcVO, Date validTo )
  {
    statistikVO.inserts++;

    try
    {
      TransferVO vo = IpcValidityDelegate.getInstance().setIpc( ipcVO, validTo );
      if ( vo.inserts == 1 )
      {
        statistikVO.insertsSuceed.add( ipcVO.getLogInformation() );
      }
      if ( vo.terminates == 1 )
      {
        statistikVO.terminatesSuceed.add( vo.terminatedVO.getLogInformation() );
      }
      if ( vo.exists == 1 )
      {
        statistikVO.insertsExists.add( ipcVO.getLogInformation() );
      }
    }
    catch ( Exception ex )
    {
      statistikVO.insertsFailed.add( ipcVO );
      LOG.error( "insertion failed for symbol: " + ipcVO.toString() + " with exception " + ex );
      errorOccured = true;
    }
  }

  private void update( IpcVO ipcVO )
  {
    try
    {
      statistikVO.updateValidTo++;

      Integer anz = IpcValidityDelegate.getInstance().setValidTo( ipcVO );
      if ( anz.intValue() == 1 )
      {
        statistikVO.updateValidToSuceed.add( ipcVO.getLogInformation() );
      }
      else
      {
        statistikVO.updateValidToExists.add( ipcVO.getLogInformation() );
      }
    }
    catch ( Exception ex )
    {
      statistikVO.updateValidToFailed.add( ipcVO );
      LOG.error( " update failed for symbol: " + ipcVO.toString() + " with Exception: " + ex );
      errorOccured = true;
    }
  }

}
