package ch.ige.ipcloadvalidity.util.test;

import org.apache.log4j.BasicConfigurator;

import ch.ige.ipcloadvalidity.util.ValidityProperties;
import junit.framework.TestCase;


/**
 * Testcase für Klasse ValidityProperties
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: ValidityPropertiesTest.java,v 1.9 2008/07/01 06:37:51 kuenzli Exp $
 */
public class ValidityPropertiesTest extends BasicTestCase
{
  
  public ValidityPropertiesTest(String s)
  {
    super(s);
  }

  @Override
  public void setUp(){
    System.setProperty( ValidityProperties.CONFIG, "file:///c:/jp/projects/ipcloadvalidity/install/programme/ige/ipcloadvalidity/config/ipcloadvalidity.properties" );
  }
  public void test()
  {
     try
    {
      assertEquals("c:/data/validity/unzip", ValidityProperties.getInstance().getProperty(ValidityProperties.UNZIP_DIRECTORY));
      assertEquals(null, ValidityProperties.getInstance().getProperty(ValidityProperties.VALIDITY_DATE_FROM) );
      assertEquals(null, ValidityProperties.getInstance().getProperty(ValidityProperties.VALIDITY_DATE_TO) );
      assertEquals("^ipcr_validity_(\\d{8})_core_(\\d{4}).xml$", ValidityProperties.getInstance().getProperty(ValidityProperties.VALIDITY_NAME));

      System.out.println(ValidityProperties.getInstance().getProperties());
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.toString() );
    }
  }

}
