
package ch.ige.ipcloadvalidity.xml.generate;

import ch.ige.ipcloadvalidity.xml.generate.SubclassList;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import javax.xml.bind.Dispatcher;
import javax.xml.bind.InvalidAttributeException;
import javax.xml.bind.InvalidContentObjectException;
import javax.xml.bind.LocalValidationException;
import javax.xml.bind.MarshallableObject;
import javax.xml.bind.MarshallableRootElement;
import javax.xml.bind.Marshaller;
import javax.xml.bind.MissingContentException;
import javax.xml.bind.PredicatedLists;
import javax.xml.bind.PredicatedLists.Predicate;
import javax.xml.bind.RootElement;
import javax.xml.bind.StructureValidationException;
import javax.xml.bind.UnmarshalException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.ValidatableObject;
import javax.xml.bind.Validator;
import javax.xml.marshal.XMLScanner;
import javax.xml.marshal.XMLWriter;


public class IpcrValidityList
    extends MarshallableRootElement
    implements RootElement
{

    private List _SubclassList = PredicatedLists.createInvalidating(this, new SubclassListPredicate(), new ArrayList());
    private PredicatedLists.Predicate pred_SubclassList = new SubclassListPredicate();

    public List getSubclassList() {
        return _SubclassList;
    }

    public void deleteSubclassList() {
        _SubclassList = null;
        invalidate();
    }

    public void emptySubclassList() {
        _SubclassList = PredicatedLists.createInvalidating(this, pred_SubclassList, new ArrayList());
    }

    public void validateThis()
        throws LocalValidationException
    {
        if (_SubclassList == null) {
            throw new MissingContentException("subclass-list");
        }
    }

    public void validate(Validator v)
        throws StructureValidationException
    {
        for (Iterator i = _SubclassList.iterator(); i.hasNext(); ) {
            v.validate(((ValidatableObject) i.next()));
        }
    }

    public void marshal(Marshaller m)
        throws IOException
    {
        XMLWriter w = m.writer();
        w.start("ipcr-validity-list");
        for (Iterator i = _SubclassList.iterator(); i.hasNext(); ) {
            m.marshal(((MarshallableObject) i.next()));
        }
        w.end("ipcr-validity-list");
    }

    public void unmarshal(Unmarshaller u)
        throws UnmarshalException
    {
        XMLScanner xs = u.scanner();
        Validator v = u.validator();
        xs.takeStart("ipcr-validity-list");
        while (xs.atAttribute()) {
            String an = xs.takeAttributeName();
            throw new InvalidAttributeException(an);
        }
        {
            List l = PredicatedLists.create(this, pred_SubclassList, new ArrayList());
            while (xs.atStart("subclass-list")) {
                l.add(((SubclassList) u.unmarshal()));
            }
            _SubclassList = PredicatedLists.createInvalidating(this, pred_SubclassList, l);
        }
        xs.takeEnd("ipcr-validity-list");
    }

    public static IpcrValidityList unmarshal(InputStream in)
        throws UnmarshalException
    {
        return unmarshal(XMLScanner.open(in));
    }

    public static IpcrValidityList unmarshal(XMLScanner xs)
        throws UnmarshalException
    {
        return unmarshal(xs, newDispatcher());
    }

    public static IpcrValidityList unmarshal(XMLScanner xs, Dispatcher d)
        throws UnmarshalException
    {
        return ((IpcrValidityList) d.unmarshal(xs, (IpcrValidityList.class)));
    }

    public boolean equals(Object ob) {
        if (this == ob) {
            return true;
        }
        if (!(ob instanceof IpcrValidityList)) {
            return false;
        }
        IpcrValidityList tob = ((IpcrValidityList) ob);
        if (_SubclassList!= null) {
            if (tob._SubclassList == null) {
                return false;
            }
            if (!_SubclassList.equals(tob._SubclassList)) {
                return false;
            }
        } else {
            if (tob._SubclassList!= null) {
                return false;
            }
        }
        return true;
    }

    public int hashCode() {
        int h = 0;
        h = ((127 *h)+((_SubclassList!= null)?_SubclassList.hashCode(): 0));
        return h;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer("<<ipcr-validity-list");
        if (_SubclassList!= null) {
            sb.append(" subclass-list=");
            sb.append(_SubclassList.toString());
        }
        sb.append(">>");
        return sb.toString();
    }

    public static Dispatcher newDispatcher() {
        return IpcrSymbol.newDispatcher();
    }


    private static class SubclassListPredicate
        implements PredicatedLists.Predicate
    {


        public void check(Object ob) {
            if (!(ob instanceof SubclassList)) {
                throw new InvalidContentObjectException(ob, (SubclassList.class));
            }
        }

    }

}
