package ch.ige.jipps;

import ch.ige.jipps.exception.LookupException;

/**
 * PdfShow: Holt ein Pdf aus der Datenbank und zeigt es mit einem Viewer an
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author Priska Steiner
 * @version $Id: PdfShow.java,v 1.33 2007/12/19 18:01:14 lewis_lee Exp $
 */
public class PdfShow
{
  /**
   * Erstellt einen Lookup auf das PdfStoreBean und verlangt von diesem ein PdfArr
   * @param pdf_Id int Id des für den Preview zu holenden Pdf's
   * @return byte[] mit den Pdf-Daten
   * @throws LookupException
   */
  public byte[] getPdfArr( int pdf_Id ) throws LookupException
  {
    try
    {
      return PrintJobStoreFactory.getInstance().selectPrintJob( pdf_Id ).printJobFile;
    }
    catch ( Exception rex )
    {
      LookupException exception = new LookupException( "PdfShow: " );
      exception.initCause( rex );
      throw exception;
    }
  }
}
