package ch.ige.jipps.ftp.web.test;

import java.sql.SQLException;

import junit.framework.TestCase;
import ch.ige.dbutils.dao.AbstractDAO;
import ch.ige.dbutils.util.ClientInitializer;
import ch.ige.jipps.ftp.web.util.EPAUploadClientConfigWrapper;
import ch.ige.jipps.ftp.web.util.FTPServletConfigDAO;

/**
 * Tests for PatDocDAO.
 * <p>
 * Copyright (c) 2007, Swiss Federal Institute of Intellectual Property
 * </p>
 * 
 * @author fabrizioli
 * @version $Id: EPAUploadClientWrapperTest.java,v 1.6 2009/04/29 09:02:24 fabrizioli Exp $
 */
public class EPAUploadClientWrapperTest extends TestCase
{

  private static final String BATCH_EXECUTION_PATH = "C:\\Programme\\ige\\patdocfeeder\\bin\\epaupload.bat";

  private static final String CMD_FILE_EXTENSION = "cmd";

  private static final String FTP_DESTINATION = "EPA";

  private static final String FTP_SERVLET_URL = "JippsWebApp/epaUploadServlet";

  private static final String MAIL_DESTINATIONCC = "patrizia.fabrizioli@ipi.ch";//"team_bagis@ipi.ch";

  private static final String MAIL_DESTINATION = "patrizia.fabrizioli@ipi.ch";// "team_bagis@ipi.ch";

  private static final String MAIL_SENDER = "ServerMail_JavaBatch@ipi.ch";

  private static final String MAIL_DESTINATIONISO = "patrizia.fabrizioli@ipi.ch";//"team_bagis@ipi.ch";

  private static final String MAIL_DESTINATIONCC_EPA = "patrizia.fabrizioli@ipi.ch";//"team_bagis@ipi.ch";

  private static final String MAIL_DESTINATION_EPA = "patrizia.fabrizioli@ipi.ch";// "team_bagis@ipi.ch";

  private static final String MAIL_SENDER_EPA = "PA_Info_Allgemein@ipi.ch";

  private static final String MAIL_DESTINATIONISO_EPA = "patrizia.fabrizioli@ipi.ch";//"team_bagis@ipi.ch";

  private static final boolean UPLOAD_BIBLIO = true;

  private static final String MAIL_SERVER = "mailrelay.ipip.ch";

  private static final String PATH_TO_COMFILES = "\\\\ipiebgs012.ipie.ch\\Bagis\\Batch";

  private static final String PATH_TO_RESULT_FILES = "\\\\ipiebgs012.ipie.ch\\Bagis\\Files";

  private static final String PATH_TO_RESULT_FILES_COPY = "\\\\ipiebgs012.ipie.ch\\Bagis\\Files\\Gesendet";

  private static final String PATH_TO_CLEANUP = "\\\\ipiebgs012.ipie.ch\\ftp\\EPAUpload\\Entwicklung";

  public EPAUploadClientWrapperTest( String args )
  {
    super( args );
  }

  @Override
  public void setUp() throws Exception
  {
    // super.setUp();
    ClientInitializer.initStandaloneClient();
    AbstractDAO.setRunningInJ2EEServer( false );

  }

  @Override
  public void tearDown() throws Exception
  {
    //super.tearDown();
  }

  protected FTPServletConfigDAO getDAO()
  {
    return new FTPServletConfigDAO();
  }

  public void testSelect() throws SQLException
  {
    EPAUploadClientConfigWrapper selected = this.getDAO().selectClientConfig();
    assertTrue( selected != null );
    validateParam( selected );
  }

  private void validateParam( EPAUploadClientConfigWrapper candidates )
  {
    assertEquals( BATCH_EXECUTION_PATH, candidates.getBatchExecutionPath() );
    assertEquals( CMD_FILE_EXTENSION, candidates.getCmdFileExtension() );
    assertEquals( FTP_DESTINATION, candidates.getFTPDestination() );
    assertEquals( FTP_SERVLET_URL, candidates.getFTPServletUrl() );
    assertEquals( MAIL_DESTINATION, candidates.getMailDestination() );
    assertEquals( MAIL_DESTINATIONCC, candidates.getMailDestinationCC() );
    assertEquals( MAIL_DESTINATIONISO, candidates.getMailDestinationISO() );
    assertEquals( MAIL_SENDER, candidates.getMailSender() );
    assertEquals( MAIL_DESTINATION_EPA, candidates.getMailDestinationEPA() );
    assertEquals( MAIL_DESTINATIONCC_EPA, candidates.getMailDestinationEPACC() );
    assertEquals( MAIL_DESTINATIONISO_EPA, candidates.getMailDestinationEPAISO() );
    assertEquals( MAIL_SENDER_EPA, candidates.getMailSenderEPA() );
    assertEquals( MAIL_SERVER, candidates.getMailServer() );
    assertEquals( PATH_TO_COMFILES, candidates.getPathToComfiles() );
    assertEquals( PATH_TO_RESULT_FILES, candidates.getPathToResultFiles() );
    assertEquals( PATH_TO_RESULT_FILES_COPY, candidates.getPathToResultFilesCopy() );
    assertEquals( PATH_TO_CLEANUP, candidates.getPathToCleanupData() );
  }

}
