package ch.ige.jipps.header;

/**
 * Contains the data for the print header in the report concerning the IP's base data.
 * <p>
 * Copyright (c) 2006, Swiss Federal Institute of Intellectual Property
 * </p>
 * 
 * @author unknown
 * @version $Id: PrintHeaderVO.java,v 1.3 2007/02/13 16:48:10 lewis_lee Exp $
 */
public class PrintHeaderVO implements PrintHeader
{
  /**
   * The formatted print date
   */
  private String printDate;
  /**
   * The page label
   */
  private String pageLabel;
  /**
   * The label for the formatted IP number
   */
  private String ipNumberLabel;
  /**
   * The formatted IP number
   */
  private String formattedIpNumber;

  // See interface
  public String getPrintDate()
  {
    return this.printDate;
  }

  /**
   * Sets the formatted print date.
   * 
   * @param printDate the formatted print date
   */
  public void setPrintDate( String printDate )
  {
    this.printDate = printDate;
  }

  // See interface
  public String getPageLabel()
  {
    return this.pageLabel;
  }

  /**
   * Sets the page label.
   * 
   * @param pageLabel The page label
   */
  public void setPageLabel( String pageLabel )
  {
    this.pageLabel = pageLabel;
  }

  // See interface
  public String getIpNumberLabel()
  {
    return this.ipNumberLabel;
  }

  /**
   * Sets the label for the formatted IP number.
   * 
   * @param ipNumberLabel The label for the formatted IP number
   */
  public void setIpNumberLabel( String ipNumberLabel )
  {
    this.ipNumberLabel = ipNumberLabel;
  }

  // See interface
  public String getFormattedIpNumber()
  {
    return this.formattedIpNumber;
  }

  /**
   * Sets the formatted IP number.
   * 
   * @param formattedIpNumber The formatted IP number
   */
  public void setFormattedIpNumber( String formattedIpNumber )
  {
    this.formattedIpNumber = formattedIpNumber;
  }
}
