package ch.ige.jipps.report;

import ch.ige.jipps.text.ReportTextContainer;
import java.util.List;

/**
 * One element (text block) on the report.
 * This may apply to the current state or the history.
 *
 * <p>Copyright (c) 2006, Swiss Federal Institute of Intellectual Property</p>
 * @author    Eric Lewis
 * @version   $Id: ReportElement.java,v 1.3 2007/04/02 16:06:25 lewis_lee Exp $
 */
public interface ReportElement extends ReportTextContainer
{
  /**
   * Gets the title for the text block.
   * @return The title for the text block
   */
  public String getTitle();

  /**
   * Sets the title for the text block.
   * This is the same as {@link #setReportText(String)}.
   * @param title The title for the text block
   */
  public void setTitle( String title );

  /**
   * Gets the text lines for the text block, a <code>List</code>
   * of <code>String</code>s.
   * @return The lines for the text block
   */
  public List<String> getTextLines();

  /**
   * Sets the text lines for the text block.
   * @param textLines The lines for the text block
   */
  public void setTextLines( List<String> textLines );
}
