package ch.ige.jipps.vo;

import java.sql.Date;

import ch.ige.dbutils.vo.AbstractVO;

/**
 * Contains the values from the table <code>BFAKTUR</code>, representing an invoice.
 * 
 * <p>Copyright (c) 2002-2003, Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author  Marc Bouquet
 * @version $Id: BfakturVO.java,v 1.27 2008/05/20 08:23:05 lewis_lee Exp $
 */
public class BfakturVO extends AbstractVO
{
  /**
   * The unique ID of the invoice.
   */
  public int bfaktId = 0;

  /**
   * The number of copies to print.
   */
  public int anzKopie = 0;

  /**
   * The print status of the invoice, see {@link ch.ige.util.constants.InvoiceConstants}.
   */
  public String printStatus;

  /**
   * The date when the invoice was printed.
   */
  public Date printDate;

  /**
   * The unique number of the employee who created this.
   * @see ch.ige.ipobjects.user.vo.MaVO
   */
  public Integer employeeNumber;

  /**
   * Shows when a change was published and created this letter.
   */
  public Date publicationDate;

  /**
   * The key of the IP to which the invoice belongs.
   */
  public Integer ipKey;
}
