package ch.ige.jipps.vo;

import java.math.BigDecimal;
import java.util.Date;

import ch.ige.dbutils.vo.AbstractVO;

/**
 * Contains the conglomerate of an invoice, as in 
 * {@link ch.ige.jipps.vo.BfakturVO} and an IP, as in
 * {@link ch.ige.ipobjects.common.GenericIP}.
 * 
 * <p>Copyright (c) 2002-2003, Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author  Marc Bouquet
 * @version $Id: JippsFakturVO.java,v 1.15 2008/07/01 09:53:00 lewis_lee Exp $
 */
public class JippsFakturVO extends AbstractVO
{
  /**
   * @see ch.ige.jipps.vo.BfakturVO#bfaktId
   */
  public int bfaktId = 0;

  /**
   * @see ch.ige.jipps.vo.BfakturVO#printDate
   */
  public Date bfaktDat = null;

  /**
   * The form type; a form is a letter template.
   */
  public String formartCd = "";

  /**
   * The language code, one of {@link ch.ige.util.constants.LanguageConstants}.
   */
  public String sprachCd = "";

  /**
   * The unique number of an address to send the invoice to.
   * @see ch.ige.ipobjects.address.Address
   */
  public int adrNr = 0;

  /**
   * @see ch.ige.ipobjects.common.GenericIP#getIPKey()
   */
  public int schutitKey = 0;

  /**
   * @see ch.ige.ipobjects.common.GenericIP#getIPNumber()
   */
  public String schutitNr = "";

  /**
   * The type of IP, one of {@link ch.ige.util.constants.IpTypeConstants}.
   */
  public int schutitTyp = 0;

  /**
   * The IP's owner.
   */
  public String inhaber = "";

  /**
   * The first line of the signature name.
   */
  public String untName = "";

  /**
   * The customer's reference.
   */
  public String ihrZeichen = "";

  /**
   * The IPI's reference.
   */
  public String unsereRef = "";

  /**
   * The phone number of the IPI employee.
   */
  public String telNr = "";

  /**
   * Shows whether the letter is sent as registered mail.
   */
  //TODO Create constants for this
  public String kzEinschr = "";

  /**
   * The type of correction.
   */
  //TODO Create constants for this
  public String kzKorrektur = "";

  /**
   * The text number for a possible letter attachment.
   */
  public int txtNrBeilage = 0;

  /**
   * The text number for the final sentences.
   */
  public int txtSchluss = 0;

  /**
   * Some text that may vary.
   */
  public String varText = "";

  /**
   * The person to whom is letter is targeted.
   */
  public int txtAdrZusatz = 0;

  /**
   * The date when the invoice must be paid.
   */
  public Date verfallDat = null;

  /**
   * The amount to pay for the invoice.
   */
  public BigDecimal faktBetrag = new BigDecimal( 0 );

  /**
   * Shows when a change was published and created this letter.
   */
  public Date publicationDate;

  /**
   * @see ch.ige.ipobjects.common.GenericIP#getDescription()
   */
  public String beschreibung = "";

  /**
   * @see ch.ige.ipobjects.common.GenericIP#getProtectionStart()
   */
  public Date schutzbeginn = null;

  /**
   * @see ch.ige.ipobjects.common.GenericIP#getProtectionEnd()
   */
  public Date schutzende = null;

  /**
   * The <strong>formatted</strong> application number for a <strong>trademark</strong>.
   * @see ch.ige.ipobjects.common.GenericIP#getApplicationNumber()
   */
  public String gesuchNr = "";
}
