package ch.ige.jipps.vo;

import java.sql.Timestamp;

import ch.ige.dbutils.vo.AbstractVO;

/**
 * Contains a cancellation for an IP. This is normally used for patents.
 * 
 * <p>Copyright (c) 2002-2003, Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author  Marc Bouquet
 * @version $Id: LoeschungVO.java,v 1.4 2007/04/24 11:46:55 lewis_lee Exp $
 */
public class LoeschungVO extends AbstractVO
{
  /**
   * The unique ID for the cancellation run
   */
  public int loeschungLaufId = 0;

  /**
   * The unique ID of the invoice used
   */
  public int bfaktId = 0;

  /**
   * The unique number of an address to send the invoice to.
   * @see ch.ige.ipobjects.address.Address
   */
  public int adrNr = 0;

  /**
   * The print recipient group
   */
  public String druckPeri = "";

  /**
   * The number of the tray to put the paper into.
   */
  public int fachNr = 0;

  /**
   * The IP type, see {@link ch.ige.util.constants.IpTypeConstants} 
   */
  public int schutitTyp = 0;

  /**
   * The address number for the cancellation letter
   */
  public int adrNrVtr = 0;

  /**
   * The text to sort with
   */
  public String sortTxt = "";

  /**
   * The processing status, one of {@link ch.ige.util.constants.CancellationProcessingConstants}
   */
  public Integer verarbStat;

  /**
   * The XML document for the cancellation letter
   */
  public String loeschungXml = "";

  /**
   * The creation date.
   */
  public Timestamp createDate = null;

  /**
   * The date of the latest update.
   */
  public Timestamp changedDate = null;
}
