package ch.ige.jipps.xml.test;

import org.custommonkey.xmlunit.XMLTestCase;
import org.custommonkey.xmlunit.XMLUnit;

import ch.ige.dbutils.dao.AbstractDAO;
import ch.ige.dbutils.dao.DAO;
import ch.ige.jipps.configuration.PathConfiguration;
import ch.ige.util.client.ClientLogInitalizer;

/**
 * Contains the base class for testing DAOs that create XML documents. This sets the System property for using its own
 * JDBC connection. This class name doesn't end with <code>Test</code> because otherwise JUnit would try to test it
 * and fail.
 * <p>
 * Copyright (c) 2006, Eidgenössisches Institut für Geistiges Eigentum
 * </p>
 * 
 * @author Eric Lewis
 * @version $Id: BaseDaoXmlTestTemplate.java,v 1.15 2007/02/01 09:11:14 lewis_lee Exp $
 */
public abstract class BaseDaoXmlTestTemplate extends XMLTestCase
{
  static
  {
    ClientLogInitalizer.initializeLoggingForTests( true, true );
    AbstractDAO.setRunningInJ2EEServer( false );
    System.setProperty( DAO.STANDALONE_CONFIG_PROPERTY_NAME, "true" );
  }

  /**
   * The default constructor
   * 
   * @param args Any arguments
   */
  public BaseDaoXmlTestTemplate( String args )
  {
    super( args );
  }

  /**
   * Lets XMLUnit ignore whitespace and configures the environment.
   * 
   * @throws Exception if setting up fails
   */
  public void setUp() throws Exception
  {
    super.setUp();
    XMLUnit.setIgnoreWhitespace( true );
    PathConfiguration.setPathsForLocalTest();
  }
}
