package ch.ige.pctedi.client;

import java.io.File;
import java.io.FilenameFilter;
import java.util.ArrayList;
import java.util.List;

/**
 * 
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   ruegsegger
 * @version  $Id: PctFile.java,v 1.3 2008/07/01 07:08:10 kuenzli Exp $
 */
public class PctFile extends File
{
  private static final long serialVersionUID = 2355720028908739319L;

  /**
   * Directory wo sich Zipfiles befinden, wird aus Properties gelesen.
   */
  public PctFile()
  {
    super( PctProperties.getInstance().getProperty( PctProperties.ZIPFILE_TARGET ) );

    this.mkdirs();
  }

  /**
   * Gibt ein Array von Files zurück die dem Format entsprechen
   * @return File[] Array von File
   */
  public PctZipFile[] listPctZipFiles()
  {
    return this.listPctZipFiles( new PctFileFilter() );
  }

  /**
   * Gibt ein Array von ValidityFiles zurück die dem Filter entsprechen
   * @param filter FilenameFilter Filter für Validity-Files
   * @return ValidityFile[] Array von Validity-Files
   */
  private PctZipFile[] listPctZipFiles( FilenameFilter filter )
  {
    String ss[] = list();
    if ( ss == null )
      return null;
    List<PctZipFile> listFiles = new ArrayList<PctZipFile>();
    for ( int i = 0; i < ss.length; i++ )
    {
      if ( ( filter == null ) || filter.accept( this, ss[i] ) )
      {
        listFiles.add( new PctZipFile( this.getPath(), ss[i] ) );
      }
    }
    return listFiles.toArray( new PctZipFile[0] );
  }
}
