package ch.ige.pctedi.client.batch.test;

import ch.ige.pctedi.client.batch.MailMessage;
import ch.ige.pctedi.client.test.ClientTestCase;

/**
 * junit test for class MailMessage, sends email mail with and without attachement
 * set activation.jar and mail.jar in classpath before j2ee.jar
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   ruegsegger
 * @version  $Id: TestMailMessage.java,v 1.10 2008/03/11 14:11:01 ruegsegger Exp $
 */
public class TestMailMessage extends ClientTestCase
{

  public TestMailMessage( String s )
  {
    super( s );
  }

  public void testSendMailWithAttach()
  {
    System.out.println( "TEST Send Mail with attachement" );

    String subject = "SUCCESS";
    String body = "Erfolgreiche Verarbeitung";
    String attachement = "C:\\jp\\projects\\pctedi\\install\\programme\\ige\\pctedi\\config\\pct.properties";

    try
    {
      MailMessage message = new MailMessage( subject, body, attachement );
      message.send();

      assertTrue( true );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }

  public void testSendMailWithoutAttach()
  {
    System.out.println( "TEST Send Mail without attachement" );

    String subject = "SUCCESS";
    String body = "Erfolgreiche Verarbeitung";
    String attachement = null;

    try
    {
      MailMessage message = new MailMessage( subject, body, attachement );
      message.send();

      assertTrue( true );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }
}
