package ch.ige.pctedi.client.gazette;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version Id:
 */
public class GazetteFile extends File
{
  /**
   * Default id.
   */
  private static final long serialVersionUID = 1L;
  // statisch da innerhalb rekursiver Funktion Konstruktor aufgerufen wird
  private static List<File> listGazette = new ArrayList<File>();

  public GazetteFile( String filename )
  {
    super( filename );
  }

  public GazetteFile( String parent, String child )
  {
    super( parent, child );
  }

  /**
   * Gibt ein Array von Gazette Files zurück die dem Filter entsprechen
   * Die Subdirectories werden rekursiv durchlaufen
   * @param filter GazetteFileFilter Filter für Gazette-Files
   * @return GazetteFile[] Array von Gazette-Files leere Liste falls keine gefunden
   */
  public List<File> listFiles( GazetteFileFilter filter )
  {
    listGazette = new ArrayList<File>();

    // Aufruf rekursive Funktion
    listGazetteFiles( filter );

    return listGazette;
  }

  /**
   * Gibt ein Array von Gazette Files zurück die dem Filter entsprechen
   * Die Subdirectories werden rekursiv durchlaufen
   * @param filter GazetteFileFilter Filter für Gazette-Files
   * @return GazetteFile[] Array von Gazette-Files
   */
  public void listGazetteFiles( GazetteFileFilter filter )
  {
    String ss[] = this.list();
    if ( ss != null )
    {
      for ( int i = 0; i < ss.length; i++ )
      {
        GazetteFile file = new GazetteFile( this.getPath(), ss[i] );

        if ( file.isDirectory() )
        {
          file.listGazetteFiles( filter );
        }
        else if ( ( filter == null ) || filter.accept( file ) )
        {
          listGazette.add( file );
        }
      }
    }
  }

}
