package ch.ige.pctedi.client.wpa.test;

import java.io.FileInputStream;
import java.util.List;

import ch.ige.pctedi.client.XMLDoc;
import ch.ige.pctedi.client.test.ClientTestCase;
import ch.ige.pctedi.client.wpa.Ereignis;
import ch.ige.pctedi.vo.EreignisVO;

/**
 * junit test of class Ereignis
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   ruegsegger
 * @version  $Id: TestEreignis.java,v 1.12 2008/03/11 14:11:01 ruegsegger Exp $
 */
public class TestEreignis extends ClientTestCase
{
  private Ereignis ereignis;

  private XMLDoc xml;

  private String filename = "C:\\jp\\projects\\pctedi\\testfiles\\wpa_GB0403434_17022005.xml";

  public TestEreignis( String s )
  {
    super( s );
  }

  @Override
  protected void setUp()
  {
    try
    {
      FileInputStream fi = new FileInputStream( filename );
      xml = new XMLDoc( fi );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }

  public void test00()
  {
    EreignisVO vo = new EreignisVO();

    try
    {
      ereignis = new Ereignis();
      List<EreignisVO> listEreignisVO = ereignis.extract( xml );

      assertTrue( listEreignisVO.size() == 2 );

      vo = listEreignisVO.get( 0 );

      assertEquals( 2004080905, vo.ereigIdat );
      assertEquals( 20, vo.ereigStatNr );
      assertEquals( "30000", vo.artNr );
      assertEquals( 0, vo.kzKorrekt );
      assertEquals( 8, vo.regStat );
      assertNull( vo.erfassDat );
      assertNull( vo.fristablDat );

      vo = listEreignisVO.get( 1 );

      assertEquals( 2005021705, vo.ereigIdat );
      assertEquals( 0, vo.ereigStatNr );
      assertEquals( "30010", vo.artNr );
      assertEquals( 0, vo.kzKorrekt );
      assertEquals( 8, vo.regStat );
      assertNull( vo.erfassDat );
      assertEquals( sdf.parse( "20040630" ), vo.fristablDat );

      // nicht durch das Programm abgefüllte Attribute (Initialwerte)
      for ( EreignisVO ereigniVO: listEreignisVO )
      {
        assertEquals( 0, ereigniVO.schutitKey );
        assertEquals( 199, ereigniVO.maNr );
        assertEquals( null, ereigniVO.publKey );
        assertNull( ereigniVO.iMaNr );
        assertNull( ereigniVO.adrNr );
        assertNull( ereigniVO.abschlDat );
        assertNull( ereigniVO.abschlmutDat );
        assertNull( ereigniVO.pmmblSeite );
        assertNull( ereigniVO.pmmblJahr );
        assertEquals( 0, ereigniVO.version );
      }
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }
}
