package ch.ige.pctedi.server;

import javax.naming.Context;
import javax.naming.InitialContext;

/**
 * Gibt den nächsten Primärschlüssel zurück.
 * Wrapper für das Bean SpidiXxIdentNumber.
 * <p>
 * Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum
 *
 * @author  Ueli Ryser
 * @version $Id: NextId.java,v 1.8 2008/03/11 14:11:01 ruegsegger Exp $
 */
public class NextId
{
  private static NextId nextId;

  private PctXxIdentNumberLocal facade;

  // Singleton
  private NextId() throws Exception
  {
    Context context = new InitialContext();
    PctXxIdentNumberLocalHome home = (PctXxIdentNumberLocalHome) context.lookup( PctXxIdentNumberLocalHome.JNDI_NAME );
    facade = home.create();
  }

  /** Gibt die einzige Instanz zurück (Singleton)
   * @return NextId
   */

  public static NextId getInstance() throws Exception
  {
    if ( nextId == null )
    {
      nextId = new NextId();
    }
    return nextId;
  }

  /**
   * Gibt den nächsten Primärschlüssel zurück.
   * Wrapper für das Bean PctXxIdentNumber.
   * @param name Name des Primärschlüssels
   * Die gültigen Werte sind in der Klasse PctXxIdentNumber
   * @return Nächster Primärschlüssel
   * @exception Exception
   */
  public int getNextId( String name ) throws Exception
  {
    return facade.getNextId( name );
  }
}
