package ch.ige.pctedi.vo;

import java.io.Serializable;
import java.util.Date;

/**
 * value object for table EREIGNIS
 *
 * <p>Copyright (c) 2008, Swiss Federal Institute of Intellectual Property</p>
 * @author   ruegsegger
 * @version  $Id: EreignisVO.java,v 1.10 2008/06/19 12:17:06 ruegsegger Exp $
 */
public class EreignisVO implements Serializable
{
  public static final String ERSTERFASSUNG = "30000";

  public static final String NATIONALE_PHASE = "30010";

  public static final String PRUEFUNG = "30040";

  public static final String NICHTEINTRITT = "30062";

  public static final int EREIG_STAT_FRIST = 0;

  public static final int EREIG_STAT_BEENDET = 19;

  public static final int EREIG_STAT_KEINE_FRIST = 20;

  public static final int EREIG_STAT_ANNULLIERT = 21;

  public static final int REGSTAT_GESUCH = 8; // Gesuchs-Ereignis ist definitiv eingetragen und erscheint auf dem Dossierauszug

  public int schutitKey = 0;

  public int ereigIdat = 0;

  public int maNr = PctVO.MA_NR;

  public Integer publKey = null;

  public int ereigStatNr = 0;

  public Integer iMaNr = null;

  public String artNr = null; //not nullable

  public Integer adrNr = null;

  public Date fristablDat = null;

  public Date abschlDat = null;

  public Date abschlmutDat = null;

  public Date erfassDat = null;

  public Integer pmmblSeite = null;

  public Integer pmmblJahr = null;

  public int kzKorrekt = 0;

  public int regStat = 0;

  public Date publDat = null;

  public int publStat = 0;

  public int version = 0;

  /**
   * Gibt den Inhalt des ValueObject EreignisVO zurück
   * @return Inhalt von EreignisVO
   */
  @Override
  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append( "  schutitKey       = <" + this.schutitKey + ">\n" );
    buf.append( "  ereigIdat        = <" + this.ereigIdat + ">\n" );
    buf.append( "  maNr             = <" + this.maNr + ">\n" );
    buf.append( "  publKey          = <" + this.publKey + ">\n" );
    buf.append( "  ereigStatNr      = <" + this.ereigStatNr + ">\n" );
    buf.append( "  iMaNr            = <" + this.iMaNr + ">\n" );
    buf.append( "  artNr            = <" + this.artNr + ">\n" );
    buf.append( "  adrNr            = <" + this.adrNr + ">\n" );
    buf.append( "  fristablDat      = <" + this.fristablDat + ">\n" );
    buf.append( "  abschlDat        = <" + this.abschlDat + ">\n" );
    buf.append( "  abschlmutDat     = <" + this.abschlmutDat + ">\n" );
    buf.append( "  erfassDat        = <" + this.erfassDat + ">\n" );
    buf.append( "  pmmblSeite       = <" + this.pmmblSeite + ">\n" );
    buf.append( "  pmmblJahr        = <" + this.pmmblJahr + ">\n" );
    buf.append( "  kzKorrekt        = <" + this.kzKorrekt + ">\n" );
    buf.append( "  regStat          = <" + this.regStat + ">\n" );
    buf.append( "  publDat          = <" + this.publDat + ">\n" );
    buf.append( "  publStat         = <" + this.publStat + ">\n" );
    buf.append( "  version          = <" + this.version + ">\n" );

    return buf.toString();
  }

}
