package ch.ige.pctedi.vo;

import java.io.Serializable;
import java.util.Date;

/**
 *
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: IpcVO.java,v 1.7 2008/07/01 07:43:05 kuenzli Exp $
 */

public class IpcVO implements Serializable
{
  /**
   * Default id.
   */
  private static final long serialVersionUID = 1L;

  public static final String ZUSATZ_CLASSIFICATION = "K"; //for classification purpose

  public static final String ZUSATZ_INDEXING = "I"; //for indexing purpose

  public static final String ZUSATZ_DOUBLE = "D"; //for both classification and indexing purpose

  public String ipcSymb = null; // not nullable

  public String zusatz = null; // not nullable

  public Date gueltigVon = null; // not nullable

  public Date gueltigBis = null;

  public String classLevel = null;

  public String corePred = null;

  public int version = 0;

  /**
   * Gibt den Inhalt des ValueObject IpcVO zurück
   * @return Inhalt von IpcVO
   */
  @Override
  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append( "  ipcSymb          = <" + this.ipcSymb + ">\n" );
    buf.append( "  zusatz           = <" + this.zusatz + ">\n" );
    buf.append( "  gueltigVon       = <" + this.gueltigVon + ">\n" );
    buf.append( "  gueltigBis       = <" + this.gueltigBis + ">\n" );
    buf.append( "  classLevel       = <" + this.classLevel + ">\n" );
    buf.append( "  corePred         = <" + this.corePred + ">\n" );
    buf.append( "  version          = <" + this.version + ">\n" );

    return buf.toString();
  }
}
