package ch.ige.pctedi.vo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * Überschrift:   Schutztitelverwaltung
 * Beschreibung:  Im JBuilderprojekt stv werden alle schutztitelspezifischen Programme zusammengefasst.
 * Copyright:     Copyright (c) 2001
 * Organisation:  IGE
 * @author:       Martin Trachsel, Daniel Haller Strahm
 * @version:      $Id: PctVO.java,v 1.10 2008/07/01 07:43:05 kuenzli Exp $
 */

/**
 * value object for PCT includes all information of a PCT 
 * centralizes informations from following tables 
 * - SCHUTIT 
 * - EREIGNIS 
 * - PRIORITAET 
 * - PAT_IPC  
 * - PAT
 * - PCTADR
 *
 * <p>Copyright (c) 2008, Swiss Federal Institute of Intellectual Property</p>
 * @author   ruegsegger
 * @version  $Id: PctVO.java,v 1.10 2008/07/01 07:43:05 kuenzli Exp $
 */
public class PctVO implements Serializable
{
  /**
   * Default id.
   */
  private static final long serialVersionUID = 1L;
  public static final int MA_NR = 199;

  public SchutitVO schutitVO;

  public List<EreignisVO> listEreignis = new ArrayList<EreignisVO>();

  public List<PrioritaetVO> listPrio = new ArrayList<PrioritaetVO>();

  public List<PatIpcVO> listPatIpc = new ArrayList<PatIpcVO>();

  public PatVO patVO;

  public List<PctAdrVO> listPctAdr = new ArrayList<PctAdrVO>();

  public String kind;

}
