package ch.ige.rbbagisexport.common;

import java.io.Serializable;

/**
 * Container to collect and provide summary of exported Files.
 * 
 * Copyright (c) 2008, Eidgenössisches Institut für Geistiges Eigentum
 * @author M. Künzli
 * @version $Id: RBBagisExportSummary.java,v 1.2 2008/04/24 14:16:31 kuenzli Exp $
 */
public class RBBagisExportSummary implements Serializable
{
  private static final long serialVersionUID = 1L;
  private StringBuffer exportedFileNames = new StringBuffer();
	private int numberExportedFiles = 0;

	/**
	 * @return String with all Names of Files that have been exported.
	 */
	public String getExportedFileNames()
	{
		return this.exportedFileNames.toString();
	}
	
  /**
   * Add passed text to list of exported file names.
   * @param text
   */
  public void addToExportedFileNames(String text){
  	this.exportedFileNames = this.exportedFileNames.append(text).append('\n');
  	this.numberExportedFiles += 1;
  	}

	/**
	 * @return Number of files that have been exported.
	 */
	public int getNumberExportedFiles()
	{
		return numberExportedFiles;
	}
}
