package ch.ige.rbbagisexport.server.util.test;

import junit.framework.TestCase;

import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.Logger;

import ch.ige.rbbagisexport.server.util.EreignisseContainer;
import ch.ige.rbbagisexport.server.util.InvalidEreignisseList;

public class EreignisseContainerTest extends TestCase
{
  //----------------------------------------------------------------------------
  // Private Members
  //----------------------------------------------------------------------------
  // Logger
  private static final Logger LOG = Logger.getLogger( EreignisseContainerTest.class );

  //----------------------------------------------------------------------------
  // Constructor
  //----------------------------------------------------------------------------
  public EreignisseContainerTest( String arg0 )
  {
    super( arg0 );
  }

  //----------------------------------------------------------------------------
  // Public Methods
  //----------------------------------------------------------------------------
  
  //----------------------------------------------------------------------------
  // Test Methods
  //----------------------------------------------------------------------------
  // ***** Test 1 *****
  public void testEreignisListOk()
  {
    EreignisseContainer eCont = null;
    try
    {
      eCont = new EreignisseContainer( "11,1231,123" );
    }
    catch ( Exception e )
    {
      fail( "Transformation failed" );
    }
    
    try
    {
      LOG.info( "SQL Notation: " + eCont.getSqlNotation() );
    }
    catch ( Exception e )
    {
      fail( "Could not get SQL Notation" );
    }
  }

  // ***** Test 2 *****
  public void testEreignisListNok()
  {
    try
    {
      new EreignisseContainer( "11,1a31,123" );
    }
    catch ( InvalidEreignisseList e )
    {
      LOG.info( "Transformation intentionally failed: Ok!" );
      assertTrue( "Transformation intentionally failed", true );
      return;
    }
    fail("Transformation has to fail");
  }

  //----------------------------------------------------------------------------
  // Protected Methods
  //----------------------------------------------------------------------------
  protected void setUp()
  {
    // setup logger with the appropriate configuration
    BasicConfigurator.configure();
  }
}
