package ch.ige.rbbagisimport.server.dao.test;

import java.sql.SQLException;

import ch.ige.rbbagisimport.common.vo.XxSysparamsVO;
import ch.ige.rbbagisimport.server.dao.XxSysparamsDAO;

/**
 * Testklasse für den Datenzugriff auf Sysparams
 *
 * <p>Copyright (c) 2008, Swiss Federal Institute of Intellectual Property</p>
 * @author   wild
 * @version  $Id: TestXxSysparamsDAO.java,v 1.2 2008/05/06 13:54:36 wild Exp $
 */
public class TestXxSysparamsDAO extends DAOTestCase
{
  /**
   * Standart-Constructor
   * @param s
   */
  public TestXxSysparamsDAO( String s )
  {
    super( s );
  }

  /**
   * Testen ob etwas gelesen wird.
   */
  public void testSysparam()
  {
    XxSysparamsDAO xSD = new XxSysparamsDAO();

    String result = "";
    try
    {
      result = xSD.getParameter( Integer.valueOf( 6 ) );
    }
    catch ( SQLException e )
    {
      fail( e.getMessage() );
    }
    assertEquals( result, "01.07.2002" );
  }

  /**
   * Testen vom VO
   */
  public void testSysparamVO01()
  {
    XxSysparamsVO sysParamVO = new XxSysparamsVO();

    sysParamVO.loadParam( XxSysparamsVO.RB_IMPORT_FOLDER_PROCESSED_PARAM_ID, "gaga01" );
    sysParamVO.loadParam( XxSysparamsVO.RB_IMPORT_PATH, "gaga02" );
    sysParamVO.loadParam( XxSysparamsVO.RB_IMPORT_SMTP_HOST_PARAM_ID, "gaga03" );

    assertEquals( "gaga02", sysParamVO.getParam( XxSysparamsVO.RB_IMPORT_PATH ) );

  }

  /**
   * Testen von toString Methode vom VO
   */
  public void testSysparamVOtoString()
  {
    XxSysparamsVO sysParamVO = new XxSysparamsVO();

    sysParamVO.loadParam( XxSysparamsVO.RB_IMPORT_FOLDER_PROCESSED_PARAM_ID, "gaga01" );
    sysParamVO.loadParam( XxSysparamsVO.RB_IMPORT_PATH, "gaga02" );
    sysParamVO.loadParam( XxSysparamsVO.RB_IMPORT_SMTP_HOST_PARAM_ID, "gaga03" );

    assertEquals( "{60=gaga02, 63=gaga01, 44=gaga03}", sysParamVO.toString() );

  }

}
