package ch.ige.st36xmlgenerator.batch.test;

import ch.ige.st36xmlgenerator.ST36BiblGeneratorImpl;
import ch.ige.st36xmlgenerator.ST36BiblGeneratorProperties;
import ch.ige.st36xmlgenerator.batch.ST36XMLGeneratorBatch;

public class ST36XMLGeneratorBatchClientTest extends AbstractBatchTestClient
{

  static
  {
    test_mail_path = System.getProperty( "java.io.tmpdir" ) + "\\testMail\\st36xmlgenerator_test.txt";
  }

  public ST36XMLGeneratorBatchClientTest( String name )
  {
    super( name );
  }

  @Override
  protected void setUp() throws Exception
  {
    super.setUp();

    this.skiplist.add( "ipiebgs012.ipie.ch\\bagis\\files\\ST36_BIBL_" );
    this.skiplist.add( "ipiebgs012.ipie.ch\\bagis\\files\\gesendet\\ST36_BIBL_" );
    this.nokfile_name = "ST36XMLGenerator";
    this.client = new ST36XMLGeneratorBatch( false );

  }

  protected void tearDown() throws Exception
  {
    super.tearDown();
    ST36BiblGeneratorProperties props = ST36BiblGeneratorProperties.initializeFromDatabase();
    props.setStartEreigidat( 2008073125 );
    new ST36BiblGeneratorImpl().updateStartEreigidat( props );
  }

  public void testST36XMLGeneratorBatchNoArgs() throws Exception
  {
    this.executeTestAndCompareResultWithExpected( new String[] {}, false, -1, "/res/test/st36xmlgenerator_test_empty.txt" );
  }

  public void testST36XMLGeneratorBatchInvalidArgs() throws Exception
  {
    this.executeTestAndCompareResultWithExpected( new String[] { "2" }, false, 10, "/res/test/st36xmlgenerator_test_invalidPar.txt" );
  }

  public void testST36XMLGeneratorBatchInvalidDate() throws Exception
  {
    this.executeTestAndCompareResultWithExpected( new String[] { "09.10.2007" }, false, 11, "/res/test/st36xmlgenerator_test_invalidDate.txt" );
  }

  public void notestST36XMLGeneratorBatchSuccessfulWithFiles() throws Exception
  {
    this.executeTestAndCompareResultWithExpected( new String[] { "09.10.2009" }, true, 0, "/res/test/st36xmlgenerator_test_successful_WithFiles.txt" );
  }

  public void notestST36XMLGeneratorBatchSuccessfulWithoutFiles() throws Exception
  {
    this.executeTestAndCompareResultWithExpected( new String[] { "09.09.2008" }, true, 0, "/res/test/st36xmlgenerator_test_successful.txt" );
  }

}
