package ch.ige.ses.client.cypher;

import javax.swing.UIManager;
import java.awt.*;


/**
 * Cypher - Passwort Encode/Decode
 * Standartmässig kann mit dem Tool ein Passwort NUR verschlüsselt werden,
 * so dass ein verschlüsseltes Passwort nicht wieder decodiert werden kann.
 *
 * Wird dem Programm aber der Parameter "decode" übergeben, so besteht auch
 * die Möglichkeit, ein verschlüsseltes Passwort zu decodieren.
 * <p>
 * Copyright (c) 2004, Eidgenössisches Institut für Geistiges Eigentum
 * @author T. Iten
 * @version $Id: Main.java,v 1.8 2007/07/09 06:12:19 iten Exp $
 */
public class Main
{
  boolean packFrame     = false;
  boolean enableDecode  = false;                // enable mit param "decode"

  //---------------------------------------------------------------------------
  // constructors / init
  //---------------------------------------------------------------------------

  public Main()
  {
    // lazy bone
  }

  public void initFrame()
  {
    MainFrame frame = new MainFrame(enableDecode);

    //Frames überprüfen, die voreingestellte Größe haben
    //Frames packen, die nutzbare bevorzugte Größeninformationen enthalten, z.B. aus ihrem Layout
    if (packFrame)
    {
      frame.pack();
    }
    else
    {
      frame.validate();
    }

    //Das Fenster zentrieren
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height)
    {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width)
    {
      frameSize.width = screenSize.width;
    }
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);
  }

  //---------------------------------------------------------------------------
  // methods
  //---------------------------------------------------------------------------

  private void loadParams(String[] args)
  {
    for (int i = 0; i < args.length; i++)
    {
      String arg = args[i];

      // decode flag
      if ( arg.equals("decode") )
      {
        enableDecode = true;
      }

    } // for
  }


  //***************************************************************************
  // main
  //***************************************************************************

  public static void main(String[] args)
  {
    Main cypher = null;

    try
    {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());

      cypher = new Main();
      cypher.loadParams(args);
      cypher.initFrame();
    }
    catch(Exception ex)
    {
      System.err.println("Cypher error occured");
      System.err.println("   Exception:" + ex.toString());
      System.err.println("   StackTrace:");
      ex.printStackTrace();
    }
  }

} // end class

