package ch.ige.ses.server.bagisoutbound.test;

import java.sql.*;
import junit.framework.*;

import ch.ige.ses.server.bagisoutbound.*;
import ch.ige.ses.util.*;
import ch.ige.util.*;
import ch.ige.util.server.*;
import ch.ige.ses.server.dao.bagis.BagisDAO;

/**
 * Test des Beans zur Verarbeitung Annullationen von BAGIS-Rechnungen
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author   Pirmin Suter
 * @version  $Id: SESRechnungAnnullationBeanTest.java,v 1.15 2006/12/13 14:54:56 iten Exp $
 * <p>
 */

public class SESRechnungAnnullationBeanTest extends TestCase
{

  //---------------------------------------------------------------------------
  // constructor
  //---------------------------------------------------------------------------

  public SESRechnungAnnullationBeanTest(String s)
  {
      super (s);
  }

  //---------------------------------------------------------------------------
  // init / clean-up
  //---------------------------------------------------------------------------

  public static Test suite()
  {
     return new TestSuite(SESRechnungAnnullationBeanTest.class);
  }

  protected void setUp() throws Exception
  {
    // lazy bone
  }

  protected void tearDown()
  {
    // lazy bone
  }

  //---------------------------------------------------------------------------
  // tests
  //---------------------------------------------------------------------------

  public void testDummy()
  {
    /** TODO junit - testfälle junit tauglich machen */
    assertEquals(true,true);
  }

  public void _testAnnullationRechnung()
  {
    Connection con        = null;
    Statement stmt        = null;
    PreparedStatement ps  = null;
    ResultSet rs          = null;
    String status         = "";
    String u_version      = "";
    int version           = 0;
    StringBuffer select   = new StringBuffer();

    SESFacadeHome sesFacadeHome = null;
    SESFacade sesFacade         = null;

    //SESRechnungAnnullationHome sesrechnungannullationHome = null;

    try
    {
      con = ch.ige.util.server.DBHelper.getConnection(BagisDAO.DSN);
      select.append("SELECT status_zahlg, u_version, version ");
      select.append("FROM bfaktur  ");
      select.append("WHERE bfakt_id = " + 3616251);

      stmt = con.createStatement();
      rs = stmt.executeQuery(select.toString());

      while (rs.next())
      {
        status = rs.getString("status_zahlg");
        u_version = rs.getString("u_version");
        version = rs.getInt("version");
      }
      rs.close();
      stmt.close();
      System.out.println(" " + version + " " + u_version + " " + status);

      sesFacadeHome = (SESFacadeHome)ServiceLocator.getInstance().getHome(SESFacadeHome.JNDI_NAME,SESFacadeHome.class);

      // Remote - Interface erstellen
      sesFacade = sesFacadeHome.create();

      sesFacade.AnnullationRechnung(3616251, SESConstants.HERKUNFT_BATCH);

      con = ch.ige.util.server.DBHelper.getConnection(BagisDAO.DSN);
      select.append("SELECT status_zahlg ");
      select.append("FROM bfaktur  ");
      select.append("WHERE bfakt_id = " + 3616251);

      stmt = con.createStatement();
      rs = stmt.executeQuery(select.toString());

      while (rs.next())
      {
        assertEquals(rs.getString("status_zahlg"),"A");
        u_version = rs.getString("u_version");
        version = rs.getInt("version");
      }
      rs.close();
      stmt.close();

      con = ch.ige.util.server.DBHelper.getConnection(BagisDAO.DSN);
      ps = con.prepareStatement(
          "UPDATE bfaktur b from U_VERSION u " +
                "SET status_zahlg = '" + status + "', version = " + version + ", " +
                "u_version	= '" + u_version + "' " +
                "WHERE b.bfakt_id = ? ");

      ps.setInt(1, 3616251);
      ps.executeUpdate();
    }
    catch (Exception e)
    {
      e.printStackTrace();
      fail(e.getMessage());
    }
    finally
    {
      DBHelper.close(ps, con);
    }
  }
}

