package ch.ige.ses.server.dao.ses.test;

import java.util.*;
import ch.ige.ses.server.dao.ses.*;
import ch.ige.ses.vo.bagis.*;
import junit.framework.*;

/**
 * Test der Klasse BfaktJGBSES
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Stefan Nydegger
 * @version $Id: BfaktJGBSESDAOTest.java,v 1.8 2007/01/04 15:58:08 iten Exp $
 */
public class BfaktJGBSESDAOTest extends SesTestCase
{

  //---------------------------------------------------------------------------
  // constructor
  //---------------------------------------------------------------------------

  public BfaktJGBSESDAOTest(String s)
  {
    super(s);
  }

  //---------------------------------------------------------------------------
  // init / clean-up
  //---------------------------------------------------------------------------

  public static Test suite()
  {
     return new TestSuite(BfaktJGBSESDAOTest.class);
  }

  protected void setUp() throws Exception
  {
    // lazy bone
  }

  protected void tearDown()
  {
    // lazy bone
  }

  //---------------------------------------------------------------------------
  // tests
  //---------------------------------------------------------------------------

  public void testDummy()
  {
    /** TODO junit - testfälle junit tauglich machen */
    assertEquals(true,true);
  }

  public void _testInsert()
  {
		System.out.println("Test INSERT");
    BfaktJGBSESDAO bfaktJGBSESDAO = new BfaktJGBSESDAO();
    SAPJGBParamVO sapJGBParamVO = new SAPJGBParamVO();

		sapJGBParamVO.bfakt_id = 1000;
		sapJGBParamVO.adr_nr = 1000;
		sapJGBParamVO.druck_art = "I";
		sapJGBParamVO.adr_nr_vtr = 1000;
		sapJGBParamVO.druckperi = "I";
		sapJGBParamVO.fach_nr = 1000;
		sapJGBParamVO.listenart = "I";
		sapJGBParamVO.sort_text = "I";

    try
    {

      bfaktJGBSESDAO.insert(sapJGBParamVO);
      // testen ob Datensatz eingefügt wurde
      sapJGBParamVO = bfaktJGBSESDAO.select(1000, 1000);
      assertEquals("1. Test: bfaktId: ", sapJGBParamVO.bfakt_id, 1000);
      assertEquals("2. Test: adr_nr: ", sapJGBParamVO.adr_nr, 1000);
      assertEquals("3. Test: druck_art: ", sapJGBParamVO.druck_art, "I");
			assertEquals("4. Test: adr_nr_vtr: ", sapJGBParamVO.adr_nr_vtr, 1000);
			assertEquals("5. Test: druckperi: ", sapJGBParamVO.druckperi, "I");
			assertEquals("6. Test: fach_nr ", sapJGBParamVO.fach_nr, 1000);
			assertEquals("7. Test: listenart ", sapJGBParamVO.listenart, "I");
			assertEquals("8. Test: sort_text ", sapJGBParamVO.sort_text, "I");
    }
    catch(Exception e)
    {
      e.printStackTrace();
      fail(e.toString());
    }
  }


  public void _testSelect()
  {
    System.out.println("Test SELECT ");
    BfaktJGBSESDAO bfaktJGBSESDAO = new BfaktJGBSESDAO();
    SAPJGBParamVO sapJGBParamVO = new SAPJGBParamVO();
    try
    {
      sapJGBParamVO = bfaktJGBSESDAO.select(1000, 1000);

      assertEquals("bfakid: ", sapJGBParamVO.bfakt_id, 1000);
      assertEquals("adr_nr: ", sapJGBParamVO.adr_nr, 1000);
                        assertEquals("druck_art: ", sapJGBParamVO.druck_art, "U");
                        assertEquals("druckperi: ", sapJGBParamVO.druckperi, "U");
    }
    catch(Exception e)
    {
      e.printStackTrace();
      fail(e.toString());
    }
  }


  public void _testSelectAll()
  {
    System.out.println("Test SELECT mehrere VO");
    BfaktJGBSESDAO bfaktJGBSESDAO = new BfaktJGBSESDAO();
    SAPJGBParamVO[] sapJGBParamVO;
    SAPJGBParamVO sapPos = new SAPJGBParamVO();
                sapPos.bfakt_id = 1000;
                sapPos.adr_nr = 2000;

                ArrayList al = new ArrayList();

    try
    {
                        // ein zweiter Datensatz einfügen
                  bfaktJGBSESDAO.insert(sapPos);

                        //selektieren
      al = bfaktJGBSESDAO.select(1000);
      sapJGBParamVO = (SAPJGBParamVO[])al.toArray(new SAPJGBParamVO[0]);

      assertTrue("Anzahl = ", al.size()==2);
      for ( int i = 0; i < sapJGBParamVO.length; i++)
      {
        assertTrue("bfakt_id: ", sapJGBParamVO[i].bfakt_id == 1000);
      }
    }
    catch(Exception e)
    {
      e.printStackTrace();
      fail(e.toString());
    }
  }


  public void _testSelectCount()
  {
    System.out.println("Test SELECT COUNT");
    BfaktJGBSESDAO bfaktJGBSESDAO = new BfaktJGBSESDAO();

    try
    {
      int anz = bfaktJGBSESDAO.selectCount(1000);

      assertEquals("Anzahl: ", anz, 2);
    }
    catch(Exception e)
    {
      e.printStackTrace();
      fail(e.toString());
    }
  }


  public void _testUpdate()
  {
    System.out.println("Test UPDATE ");
    BfaktJGBSESDAO bfaktJGBSESDAO = new BfaktJGBSESDAO();
    SAPJGBParamVO sapJGBParamVO = new SAPJGBParamVO();

    try
    {
      sapJGBParamVO = bfaktJGBSESDAO.select(1000, 1000);
      if (sapJGBParamVO == null)
      {
        System.out.println("UPDATE: Datensatz existiert nicht");
      }
      else
      {
        // Datensatz ändern
        sapJGBParamVO.druck_art = "U";
        sapJGBParamVO.druckperi = "U";
        int retVal = bfaktJGBSESDAO.update(sapJGBParamVO);
        assertEquals("Anzahl geänderter Datensätze: ", retVal, 1);
        //Datensatz wieder selektieren und testen, ob Änderungen übernommen
        sapJGBParamVO = bfaktJGBSESDAO.select(1000, 1000);
        assertEquals(sapJGBParamVO.druck_art, "U");
				assertEquals(sapJGBParamVO.druckperi, "U");
      }
    }
    catch(Exception e)
    {
      e.printStackTrace();
      fail(e.toString());
    }
  }


  public void _testDelete()
  {
    System.out.println("Test DELETE");
    BfaktJGBSESDAO bfaktJGBSESDAO = new BfaktJGBSESDAO();
    try
    {
      int retVal = bfaktJGBSESDAO.delete(1000, 1000);
      assertEquals("1 gelöschter Datensatz",retVal, 1);
    }
    catch(Exception e)
    {
      e.printStackTrace();
      fail(e.toString());
    }
  }

} // end class

