package ch.ige.ses.server.sapctrl;

import ch.ige.ses.vo.bagis.*;
import ch.ige.ses.vo.ses.*;
import ch.ige.util.*;

/**
 * Delegate for SapOutboundCtrlBean
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author T. Iten
 * @version $Id: SapDelegateOutbound.java,v 1.17 2006/12/29 12:23:20 iten Exp $
 */
public class SapDelegateOutbound
{
  //
  // fields
  //
  private static SapDelegateOutbound  fDelegate         = null;
  private        SapOutboundCtrl      fSapOutboundCtrl  = null;


  //---------------------------------------------------------------------------
  // constructors
  //---------------------------------------------------------------------------

  private SapDelegateOutbound() throws Exception
  {
    SapOutboundCtrlHome  home;

    home = (SapOutboundCtrlHome) ServiceLocator.getInstance().getHome
                                   (SapOutboundCtrlHome.JNDI_NAME, SapOutboundCtrlHome.class);

    this.fSapOutboundCtrl = home.create();
  }

  //---------------------------------------------------------------------------
  // methods
  //---------------------------------------------------------------------------

  public static SapDelegateOutbound getInstance() throws Exception
  {
    if (fDelegate == null)
    {
      fDelegate = new SapDelegateOutbound();
    }
    return fDelegate;
  }

  
  public static void removeInstance() throws Exception
  {
    ServiceLocator.removeInstance();
    fDelegate = null;
  }


  public String receivePing (String request) throws Exception
  {
    return this.fSapOutboundCtrl.receivePing(request);
  }


  public void receiveStatus(final SAPRechnungStatusListVO list) throws Exception
  {
    fSapOutboundCtrl.receiveStatus(list);
  }


  public void receiveStatusJGB(SAPRechnungStatusListVO list) throws Exception
  {
    this.fSapOutboundCtrl.receiveStatusJGB(list);
  }


  public void receiveError(ErrorVO err) throws Exception
  {
    this.fSapOutboundCtrl.receiveError(err);
  }


  public void receiveTrace(TraceVO trace) throws Exception
  {
    this.fSapOutboundCtrl.receiveTrace(trace);
  }

} // end class


