package ch.ige.ses.vo.ses;

import java.sql.Date;
import java.io.Serializable;

/**
 * SAP Stako Controlling VO um beim SapInbound Service
 * die Stako-Verarbeitung zu starten.
 * <p>
 * Copyright (c) 2003, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Stefan Nydegger
 * @version $Id: SAPStakoJobVO.java,v 1.5 2006/12/13 14:58:39 iten Exp $
 */

public class SAPStakoJobVO implements Serializable
{
  //----------------------------------------------------------------------------
  // const
  //----------------------------------------------------------------------------
  public static final int STAKO_MODUS_START    = 0;  // Komplette Stako-Verarbeitung
  public static final int STAKO_MODUS_RESTART  = 1;  // Restart einer fehlgeschlagenen Stako-Verarbeitung
  public static final int STAKO_MODUS_UPDATE   = 2;  // nur Updaten der Artikel, ohne Stako-Verarbeitung
  public static final int STAKO_MODUS_NOUPDATE = 3;  // nur Stako-Verarbeitung, ohne update Artikel

  //
  // fields
  //
  public int      modus         = 0;
  public Date     bisDatum      = null;

  //----------------------------------------------------------------------------
  // constructors
  //----------------------------------------------------------------------------

  public SAPStakoJobVO()
  {
    // lazy bone
  }

  //----------------------------------------------------------------------------
  // methods
  //----------------------------------------------------------------------------
  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append("  modus        =  " + this.modus    + "\n");
    buf.append("  bisDatum     =  " + this.bisDatum + "\n");
    return buf.toString();
  }
}

