package ch.ige.wdltool.ejb;

import ch.ige.wdltool.analyzer.AnalysisResultVO;
import ch.ige.wdltool.exception.WrappedRuntimeException;

/**
 * Contains the services offered to local callers.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Christian Heinzer
 * @version  $Id: WdlLocalServices.java,v 1.1 2008/04/17 13:39:33 heinzer Exp $
 */
public interface WdlLocalServices
{

  /**
   * Analyzes the WDL of a trademark with known ipKey
   * @param ipKey The IP key of the trademark to analyze
   * @return Logging information with details for the analyzed WDL. 
   * @throws WrappedRuntimeException if the WDL analyse process failed
   */
  public AnalysisResultVO analyzeWdl( int ipKey ) throws WrappedRuntimeException;
}