package ch.ige.wdltool.ejb;

import java.util.Collection;
import java.util.List;

import ch.ige.wdltool.dao.ClassDAO;
import ch.ige.wdltool.vo.ClassVO;

/**
 * Tests {@link ch.ige.wdltool.ejb.WdlServices} for classes.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Eric Lewis
 * @version  $Id: WdlServicesForClassTest.java,v 1.5 2007/12/11 10:10:21 heinzer Exp $
 */
public class WdlServicesForClassTest extends BaseServiceTestTemplate<ClassDAO, ClassVO, Integer, WdlServices>
{
  /**
   * The unit under test
   */
  private WdlServices wdlServices;

  /**
   * The only constructor.
   * @param name The test's name
   */
  public WdlServicesForClassTest( String name )
  {
    super( name );
    this.wdlServices = WdlServicesFactory.getStandaloneWdlServices();
  }

  /**
   * Tests {@link ch.ige.wdltool.ejb.WdlServices#findAllClasses()}.
   * @throws Exception if the test fails
   */
  public void testFindAllClasses() throws Exception
  {
    List<ClassVO> classes = (List<ClassVO>) read( (Object[]) null );
    // There's not much to do, really...
    assertEquals( "Check number of classes", 45, classes.size() );
    for ( int i = 0; i < classes.size(); i++ )
    {
      ClassVO classVO = classes.get( i );
      assertEquals( "Checking class number", i + 1, classVO.getClassNumber().intValue() );
    }
  }

  // @see ch.ige.wdltool.ejb.BaseServiceTestTemplate#getServices()
  @Override
  protected WdlServices getServices()
  {
    return this.wdlServices;
  }

  // @see ch.ige.wdltool.ejb.BaseServiceTestTemplate#readWithService(java.lang.Object[])
  @Override
  @SuppressWarnings( "unused" )
  public Collection<ClassVO> readWithService( Object... searchParameters ) throws Exception
  {
    return getServices().findAllClasses();
  }
}
