package ch.ige.wdltool.ejb.impl;

import java.sql.SQLException;
import java.util.List;

import ch.ige.wdltool.dao.DataSourceDAO;
import ch.ige.wdltool.enums.DataSource;
import ch.ige.wdltool.vo.DataSourceVO;

/**
 * Implements services for data sources.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Eric Lewis
 * @version  $Id: DataSourceImpl.java,v 1.3 2008/01/18 12:08:09 lewis_lee Exp $
 */
public class DataSourceImpl extends BaseServicesImpl<DataSourceDAO, DataSourceVO, DataSource>
{
  // @see ch.ige.wdltool.ejb.impl.BaseServicesImpl#getObjectName()
  @Override
  protected String getObjectName()
  {
    return "data source";
  }

  // @see ch.ige.wdltool.ejb.impl.BaseServicesImpl#getDAOClass()
  @Override
  protected Class<DataSourceDAO> getDAOClass()
  {
    return DataSourceDAO.class;
  }

  // @see ch.ige.wdltool.ejb.impl.BaseServicesImpl#find(ch.ige.dbutils.dao.DAO, java.io.Serializable)
  @Override
  protected DataSourceVO find( DataSourceDAO dao, DataSource id ) throws SQLException
  {
    return dao.find( id );
  }

  // @see ch.ige.wdltool.ejb.impl.BaseServicesImpl#findAll(ch.ige.dbutils.dao.DAO)
  @Override
  protected List<DataSourceVO> findAll( DataSourceDAO dao ) throws SQLException
  {
    return dao.findAll();
  }

  // @see ch.ige.wdltool.ejb.impl.BaseServicesImpl#update(ch.ige.dbutils.dao.DAO, ch.ige.dbutils.vo.AbstractVO)
  @Override
  protected void update( DataSourceDAO dao, DataSourceVO vo )
  {
    dao.update( vo );
  }
}