package ch.ige.wdltool.validator;

import org.hibernate.validator.Validator;

import ch.ige.wdlutil.text.CharacterChecker;

/**
 * Validates a term.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Eric Lewis
 * @version  $Id: TermValidator.java,v 1.5 2008/05/07 12:44:14 lewis_lee Exp $
 */
public class TermValidator implements Validator<Term>
{
  // @see org.hibernate.validator.Validator#initialize(java.lang.annotation.Annotation)
  @SuppressWarnings( "unused" )
  public void initialize( Term parameters )
  {
    // Nothing to do
  }

  //part of the property constraint contract
  public boolean isValid( Object value )
  {
    if ( value == null )
    {
      return true;
    }
    if ( !( value instanceof String ) )
    {
      return false;
    }
    String term = (String) value;
    if ( term.startsWith( " " ) )
    {
      return false;
    }
    if ( term.endsWith( " " ) )
    {
      return false;
    }
    return CharacterChecker.checkTerm( term ).isEmpty();
  }
}
