package ch.ige.wdltool.vo;

import ch.ige.dbutils.vo.AbstractVO;
import ch.ige.dbutils.vo.IdentifiableVO;

/**
 * Represents an analyzed trademark identified by its IP key.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Christian Heinzer
 * @version  $Id: AnalyzedVO.java,v 1.2 2008/04/18 09:44:19 heinzer Exp $
 */
public class AnalyzedVO extends AbstractVO implements IdentifiableVO<Integer>
{
  /**
   * The IP Key
   */
  private Integer ipKey;

  /**
   * Empty constructor - required for dbutils, for productive choose a/the constructor that already initialises the IP Key.  
   */
  public AnalyzedVO()
  {
    super();
  }

  /**
   * Creates this for a given IP key
   * @param ipKey The IP key to use
   */
  public AnalyzedVO( int ipKey )
  {
    super();
    this.setIPKey( ipKey );
  }

  // @see ch.ige.dbutils.vo.IdentifiableVO#getIdentifier()
  public Integer getIdentifier()
  {
    return this.ipKey;
  }

  // @see ch.ige.dbutils.vo.IdentifiableVO#setIdentifier(java.io.Serializable)
  public void setIdentifier( Integer id )
  {
    this.ipKey = id;
  }

  /**
   * Gets the IP key.
   * @return the IP key
   */
  public Integer getIPKey()
  {
    return getIdentifier();
  }

  /**
   * Sets the IP key.
   * @param ipKey The IP key to set
   */
  public void setIPKey( Integer ipKey )
  {
    this.ipKey = ipKey;
  }
}
