package ch.ige.wdltool.vo;

import ch.ige.dbutils.vo.IdentifiableVO;
import ch.ige.wdltool.enums.DataSource;
import ch.ige.wdltool.enums.TermType;
import ch.ige.wdltool.validator.SearchTerm;
import ch.ige.wdltool.validator.Term;

/**
 * Contains a term which must not be used.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Eric Lewis
 * @version  $Id: NegativeIpiTermVO.java,v 1.9 2007/09/21 09:17:03 lewis_lee Exp $
 */
public class NegativeIpiTermVO extends AbstractTermVO implements IdentifiableVO<Integer>
{
  /**
   * The empty constructor
   */
  public NegativeIpiTermVO()
  {
    super();
  }

  /**
   * Creates this from an abstract VO.
   * @param vo The VO whose values are copied
   */
  public NegativeIpiTermVO( AbstractTermVO vo )
  {
    super( vo );
  }
  
  //*********************************************************
  // Same as IpiTermVO, but individual because of validation
  //*********************************************************

  // @see ch.ige.wdltool.vo.IpiTermVO#initTermTypeAndDataSource()
  @Override
  protected void initTermTypeAndDataSource()
  {
    this.termType = TermType.NEGATIVE_IPI_TERM;
    this.dataSource = DataSource.IPI;
  }
  
  //*********************************************************
  // Same as NiceTermVO, but individual because of validation
  //*********************************************************

  // @see ch.ige.wdltool.vo.AbstractTermVO#getClassNumber()
  @Override
  public Integer getClassNumber()
  {
    return super.getClassNumber();
  }

  // @see ch.ige.wdltool.vo.AbstractTermVO#setClassNumber(java.lang.Integer)
  @Override
  public void setClassNumber( Integer classNumber )
  {
    super.setClassNumber( classNumber );
  }

  // @see ch.ige.wdltool.vo.AbstractTermVO#getTerm()
  @Override
  @Term
  public String getTerm()
  {
    return super.getTerm();
  }

  // @see ch.ige.wdltool.vo.AbstractTermVO#getSearchTerm()
  @Override
  @SearchTerm
  public String getSearchTerm()
  {
    return super.getSearchTerm();
  }

  // @see ch.ige.wdltool.vo.AbstractTermVO#isPublic()
  @Override
  public boolean isPublic()
  {
    return super.isPublic();
  }

  // @see ch.ige.wdltool.vo.AbstractTermVO#setPublic(boolean)
  @Override
  public void setPublic( boolean isPublic )
  {
    super.setPublic( isPublic );
  }
}
